//
// Class CFileManager for sending/receiving files from server
//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

//Import libraries...
import java.io.*;

public class CFileManager
{
  //Variables
  String dir_cl;
  String dir_sr;
  String dir_rel;

  String sep;

  int num_read_max=16384;
  char[] cbuf;

  //****************************************************************************
  public void Init(String sep1, String dir_cl1, String dir_sr1, String dir_rel1)
  {
    dir_cl=dir_cl1;
    dir_sr=dir_sr1;
    dir_rel=dir_rel1;
    sep=sep1;

    if (!dir_cl.equals("")) dir_cl=CMisc.ProcessDir(dir_cl, sep);
    if (!dir_sr.equals("")) dir_sr=CMisc.ProcessDir(dir_sr, sep);
    if (!dir_rel.equals("")) dir_rel=CMisc.ProcessDir(dir_rel, sep);

    cbuf=new char[num_read_max];
  }

  //****************************************************************************
  public int removeAllFiles()
  {
    String str1=dir_sr+dir_rel;

    File fl=new File(str1);
    String[] fl_list=new String[16384];

    fl_list=fl.list();
    for (int qq=0; qq<fl_list.length; qq++)
    {
      //Delete file if exist
      File fdel=null;
      try
      {
        fdel=new File(str1+fl_list[qq]);
        fdel.delete();
      }
      catch (NullPointerException e1)
      {}
    }

    return 0;
  }

  //****************************************************************************
  public int receiveFile(String filename, String dir_rel1)
  {
    if (!dir_rel1.equals("")) dir_rel1=CMisc.ProcessDir(dir_rel1, sep);

    String str1=dir_cl+dir_rel+dir_rel1+filename;
    String str2=dir_sr+dir_rel+filename;

    BufferedReader fin=null;
    BufferedWriter fout=null;

    try
    {
      fin=new BufferedReader(new FileReader(str2));
      fout=new BufferedWriter(new FileWriter(str1));
    }
    catch (IOException e2)
    {
      return -1;
    }

    int num_read=0;

    try
    {
      while ((num_read=fin.read(cbuf, 0, num_read_max))!=-1)
      {
        fout.write(cbuf, 0, num_read);
      }
    }
    catch (Exception e2)
    {
      try
      {
        fin.close();
        fout.close();
      }
      catch (Exception e3)
      {}
      return -2;
    }

    try
    {
      fin.close();
      fout.close();
    }
    catch (Exception e5)
    {
      return -3;
    }

    return 0;
  }

  //****************************************************************************
  public int receiveFile1(String filename, String dir_rel1, String filename1)
  {
    if (!dir_rel1.equals("")) dir_rel1=CMisc.ProcessDir(dir_rel1, sep);

    String str1=dir_cl+dir_rel+dir_rel1+filename1;
    String str2=dir_sr+dir_rel+filename;

    BufferedReader fin=null;
    BufferedWriter fout=null;

    try
    {
      fin=new BufferedReader(new FileReader(str2));
      fout=new BufferedWriter(new FileWriter(str1));
    }
    catch (IOException e2)
    {
      return -1;
    }

    int num_read=0;

    try
    {
      while ((num_read=fin.read(cbuf, 0, num_read_max))!=-1)
      {
        fout.write(cbuf, 0, num_read);
      }
    }
    catch (Exception e2)
    {
      try
      {
        fin.close();
        fout.close();
      }
      catch (Exception e3)
      {}
      return -2;
    }

    try
    {
      fin.close();
      fout.close();
    }
    catch (Exception e5)
    {
      return -3;
    }

    return 0;
  }

  //****************************************************************************
  public int sendFile(String filename)
  {
    String str1=dir_cl+dir_rel+filename;
    String str2=dir_sr+dir_rel+filename;

    BufferedReader fin=null;
    BufferedWriter fout=null;

    try
    {
      fin=new BufferedReader(new FileReader(str1));
      fout=new BufferedWriter(new FileWriter(str2));
    }
    catch (IOException e2)
    {
      return -1;
    }

    int num_read=0;

    try
    {
      while ((num_read=fin.read(cbuf, 0, num_read_max))!=-1)
      {
        fout.write(cbuf, 0, num_read);
      }
    }
    catch (Exception e2)
    {
      try
      {
        fin.close();
        fout.close();
      }
      catch (Exception e3)
      {}
      return -2;
    }

    try
    {
      fin.close();
      fout.close();
    }
    catch (Exception e5)
    {
      return -3;
    }

    return 0;
  }
}
