//
// eos_mpc_fb1
//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

//Import libraries...
import java.io.*;

//Main class
public class eos_mpc_fb1
{
  //**************************************************************************
  public static void main(String args[])
  {
    //Logo
    System.out.println("EOS MPC Feedback Module 1   (C) by Grigori G. Fursin   January,2002");

    String str1="_eos_mpc_info2";
    String str2="";

    String fadd="eos_mpc_fb1.fatom.c";

    String feos1="_eos_mpc_atom_tmp1";
    String feos2="_eos_mpc_atom_tmp.c";

    int proc=0;
    int inst_max=0;
    int inst_max1=0;

    int lab=0;

    int nl_max=1024;
    String[] procname=new String[nl_max];
    long[]       addr1=new long[nl_max];
    long[]       addr2=new long[nl_max];

    BufferedReader fin=null;
    BufferedWriter fout9=null;

    BufferedWriter fmpc3=null;
    BufferedWriter fmpc4=null;
    BufferedWriter fmpc5=null;

    String ffmpc3="_eos_mpc_atom_tmp2.";
    String ffmpc4="_eos_mpc_atom_tmp3.";
    String ffmpc5="_eos_mpc_atom_tmp4.";

    if (args.length>0)
    {
      if (args.length>1) str1=args[1]+"2";

      //Copying additional c file into work directory

      System.out.println("");
      System.out.println("Copying "+fadd+" into work directory ...");

      try
      {
        fin=new BufferedReader(new FileReader(args[0]+"\\"+fadd));
        fout9=new BufferedWriter(new FileWriter(fadd));
      }
      catch (IOException e2)
      {
        System.out.println("Error: Can't find additional c file!");
        System.exit(1);
      }

      try
      {
        while ((str2=fin.readLine())!=null)
        {
          fout9.write(str2);
          fout9.newLine();
        }
      }
      catch (Exception e1)
      {
        try
        {
          fin.close();
          fout9.close();
        }
        catch (Exception e2)
        {}
        System.out.println("Error: Problems copying additional c file!");
        System.exit(1);
      }
 
      try
      {
        fin.close();
        fout9.close();
      }
      catch (Exception e3)
      {}
    }

    //main
    try
    {
      fin=new BufferedReader(new FileReader(str1));
      fout9=new BufferedWriter(new FileWriter(feos1));
    }
    catch (IOException e2)
    {
      System.out.println("Error: Can't find info2 file!");
      System.exit(1);
    }

    int nl=0;  //current number of procedures
 
    try
    {
      while ((str2=fin.readLine())!=null)
      {
        if (str2.length()>0 && str2.charAt(0)=='*')
        {
          String fn=str2.substring(1,str2.length());
          nl=0;

          str2=fin.readLine();
          while ((str2=fin.readLine())!=null && !str2.equals(""))
          {
            if (str2.charAt(0)=='+')
            {
              if (nl>nl_max)
              {
                System.out.println("Error: Too many procedures in info file!");
                System.exit(1);
              }

              int i1=str2.indexOf(" ");
              procname[nl]="_"+str2.substring(1,i1).toLowerCase();

              int i2=str2.indexOf(" ", i1+1);
              String str=str2.substring(i1+1,i2);

              long addr=0;
              try
              {
                addr=Long.valueOf(str).longValue();
              }
              catch (NumberFormatException nfe1)
              {}

              addr1[nl]=addr;

              str=str2.substring(i2+1, str2.length());

              addr=0;
              try
              {
                addr=Long.valueOf(str).longValue();
              }
              catch (NumberFormatException nfe1)
              {}

              addr2[nl]=addr;

              nl++;
            }
          }

          int i1=fn.lastIndexOf(".");
          fn=fn.substring(0, i1);

          String fn1=fn+"_mpc5b.asm";
          String fn2=fn+"_mpc5b.fatom.asm";

          BufferedReader fin1=null;
          BufferedWriter fout2=null;
    
          int extrn=0;

          for (int n=0; n<=nl; n++)
          {
            //Copying from fn1 into fn2
            try
            {
               fin1=new BufferedReader(new FileReader(fn1));
              fout2=new BufferedWriter(new FileWriter(fn2));
            }
            catch (IOException e2)
            {
              System.out.println("Error: Can't open source files!");
              System.exit(1);
            }

            try
            {
              while ((str2=fin1.readLine())!=null)
              {
                fout2.write(str2);
                fout2.newLine();
              }
            }  
            catch (Exception e1)
            {
              try
              {
                fin1.close();
                fout2.close();
              }
              catch (Exception e2)
              {}
              System.out.println("Error: Problems reading source files!");
              System.exit(1);
            }

            try
            {
               fin1.close();
              fout2.close();
            }
            catch (Exception e3)
            {}

            fn1="_eos_mpc_fb1.tmp";

            //Transforming from fn2 into fn1
            if (n!=nl)
            {
              inst_max=0;

              fout9.write("proc='");
              fout9.write(procname[n]);
              fout9.write("', number='");
              fout9.write(String.valueOf(proc));
              fout9.write("'");
              fout9.newLine();
              
              System.out.println("");
              System.out.print("Searching subroutine: ");
              System.out.print(procname[n]);
              System.out.print(" (");
              System.out.print(addr1[n]);
              System.out.print(" - ");
              System.out.print(addr2[n]);
              System.out.print(")");
              System.out.println("");
              
              try
              {
                 fin1=new BufferedReader(new FileReader(fn2));
                fout2=new BufferedWriter(new FileWriter(fn1));
              }
              catch (IOException e2)
              {
                System.out.println("Error: Can't open source files!");
                System.exit(1);
              }

              try
              {
                while ((str2=fin1.readLine())!=null)
                {
                  if (str2.indexOf("_TEXT\t")!=-1 || str2.indexOf("_TEXT ")!=-1)
                  {
                    str2="_DATA\t"+str2.substring(6,str2.length());

                    i1=str2.indexOf("'CODE'");
                    if (i1!=-1)
                    {
                      str2=str2.substring(0,i1)+"'DATA'";
                    }

                    fout2.write(str2);
                    fout2.newLine();
                  }
                  else if (extrn==0 && str2.indexOf("EXTRN\t")!=-1)
                  {
                    fout2.write(str2);
                    fout2.newLine();

                    fout2.write("EXTRN\t_mpc_reg_access:PROC ;MPC");
                    fout2.newLine();

                    extrn=1;
                  }
                  else if (str2.length()>0 && str2.indexOf(" PROC ")!=-1)
                  {
                    i1=str2.indexOf(" ");
                    if (i1!=-1)
                    {
                      if (str2.substring(0,i1).toLowerCase().equals(procname[n]))
                      {
                        System.out.print("Subroutine ");
                        System.out.print(procname[n]);
                        System.out.println(" found!");

                        try
                        {
                          fmpc3=new BufferedWriter(new FileWriter(ffmpc3+String.valueOf(proc)));
                          fmpc4=new BufferedWriter(new FileWriter(ffmpc4+String.valueOf(proc)));
                          fmpc5=new BufferedWriter(new FileWriter(ffmpc5+String.valueOf(proc)));
                        }
                        catch (IOException e2)
                        {
                          System.out.println("Error: Can't open file for writing!");
                          System.exit(1);
                        }

                        inst_max=0;
                        
                        fout2.write(str2);
                        fout2.newLine();

                        boolean finish=false;
                        while (!finish && (str2=fin1.readLine())!=null)
                        {
                          if (str2.indexOf(" ENDP")!=-1)
                          {
                            fout2.write(str2);
                            fout2.newLine();

                            finish=true;
                          }
                          else
                          {                 
                            long line=getLine(str2);

                            if (str2.indexOf(" PTR ")!=-1)
//                            if (addr1[n]<=line && line<=addr2[n] && str2.indexOf(" PTR ")!=-1)
                            {
                              fmpc3.write(str2);
                              fmpc3.newLine();

                              int found1=0;
                              int rw=0;
                              String fc="";

                              if (GetInstClass(str2)==0)
                              {
                                found1=1;
                                fc="Load";
                                rw=0;
                              }
                              else if (GetInstClass(str2)==1)
                              {
                                found1=1;
                                fc="FLoad";
                                rw=0;
                              }
                              else if (GetInstClass(str2)==2)
                              {
                                found1=1;
                                fc="Store";
                                rw=1;
                              }
                              else if (GetInstClass(str2)==3)
                              {
                                found1=1;
                                fc="Fstore";
                                rw=1;
                              }

//                              if (str2.indexOf("esp")!=-1 || str2.indexOf("ebp")!=-1)
                              if (str2.indexOf("esp")!=-1)
                                found1=0;

                              if (found1!=0)
                              {
                                fmpc3.write(fc+" [");
                                fmpc3.write(String.valueOf(line));
                                fmpc3.write("]   memory access (inst=");
                                fmpc3.write(String.valueOf(inst_max));
                                fmpc3.write(")");
                                fmpc3.newLine();

                                fmpc4.write("{}, line={");
                                fmpc4.write(String.valueOf(line));
                                fmpc4.write("}, inst={");
                                fmpc4.write(String.valueOf(inst_max));
                                fmpc4.write("}");
                                fmpc4.newLine();

                                fmpc5.write("inst={");
                                fmpc5.write(String.valueOf(inst_max));
                                fmpc5.write("}");
                                fmpc5.newLine();

                                i1=str2.indexOf(" PTR ");
                                int i2=i1+5;

                                int i3=str2.indexOf("]", i2);
                                if (i3==-1)
                                {
                                  i3=str2.indexOf(",",i2);
                                  if (i3==-1)
                                  {
                                    i3=str2.indexOf(" ",i2);
                                    if (i3==-1)
                                    {
                                      i3=str2.indexOf(";",i2);
                                    }
                                  }
                                }
                                else i3++;

                                String mem=str2.substring(i2, i3);

                                String lab1="MPC_FB1_"+String.valueOf(lab);
                                lab++;

                                //Prepare call
                                fout2.write("; *** MPC start ***");fout2.newLine();

                                fout2.write(lab1+"A:");fout2.newLine();
                                fout2.write(" jmp "+lab1+"C");fout2.newLine();
                                fout2.write(lab1+"B:");fout2.newLine();
                                fout2.write(" jmp "+lab1+"D");fout2.newLine();
                                fout2.write(lab1+"C:");fout2.newLine();
                                fout2.write(" pusha");fout2.newLine();
                                fout2.write(" sub esp, 24");fout2.newLine();
                                fout2.write(" lea eax, "+mem);fout2.newLine();                       
                                fout2.write(" mov DWORD PTR [esp], eax");fout2.newLine();
                                fout2.write(" mov DWORD PTR [esp+4], "+String.valueOf(proc));fout2.newLine();
                                fout2.write(" mov DWORD PTR [esp+8], "+String.valueOf(inst_max));fout2.newLine();
                                fout2.write(" mov DWORD PTR [esp+12], "+String.valueOf(rw));fout2.newLine();
                                fout2.write(" lea eax, "+lab1+"A");fout2.newLine();
                                fout2.write(" mov DWORD PTR [esp+16], eax");fout2.newLine();
                                fout2.write(" lea eax, "+lab1+"B");fout2.newLine();
                                fout2.write(" mov DWORD PTR [esp+20], eax");fout2.newLine();
                                fout2.write(" call _mpc_reg_access");fout2.newLine();
                                fout2.write(" add esp, 24");fout2.newLine();
                                fout2.write(" popa");fout2.newLine();
                                fout2.write(lab1+"D:");fout2.newLine();
                                fout2.write("; *** MPC end ***");fout2.newLine();

                                inst_max++;
                              }

                              fout2.write(str2);
                              fout2.newLine();
                            }
                            else
                            {
                              fout2.write(str2);
                              fout2.newLine();
                            }
                          }
                        }

                        try
                        {
                          fmpc3.close();
                          fmpc4.close();
                          fmpc5.close();
                        }
                        catch (Exception e2)
                        {}

                        if (inst_max>inst_max1) inst_max1=inst_max;
                      }
                      else
                      {
                        fout2.write(str2);
                        fout2.newLine();
                      }
                    }
                    else
                    {
                      fout2.write(str2);
                      fout2.newLine();
                    }
                  }
                  else
                  {
                    fout2.write(str2);
                    fout2.newLine();
                  }
                }
              }  
              catch (Exception e1)
              {
                try
                {
                  fin1.close();
                  fout2.close();
                }
                catch (Exception e2)
                {}
                System.out.println("Error: Problems reading source files!");
                System.exit(1);
              }

              try
              {
                 fin1.close();
                fout2.close();
              }
              catch (Exception e3)
              {}

              proc++;
            }
          }
        }
      }
    }
    catch (Exception e1)
    {
      try
      {
        fin.close();
        fout9.close();
      }
      catch (Exception e2)
      {}
      System.out.println("Error: Problems reading info2 file!");
      System.exit(1);
    }
 
    try
    {
      fin.close();
      fout9.close();
    }
    catch (Exception e3)
    {}

    //Preparing 'main' file
    try
    {
      fout9=new BufferedWriter(new FileWriter(feos2));
    }
    catch (IOException e2)
    {
      System.out.println("Error: Can't open 'main' file for writing!");
      System.exit(1);
    }

    try
    {
      fout9.write("#include <stdlib.h>");fout9.newLine();
      fout9.write("#include <stdio.h>");fout9.newLine();
      fout9.write("");fout9.newLine();
      fout9.write("int mpc_finish(void);");fout9.newLine();
      fout9.write("");fout9.newLine();
      fout9.write("void mpc_init1(void)");fout9.newLine();
      fout9.write("{");fout9.newLine();
      fout9.write("  mpc_init("+String.valueOf(proc)+", "+
                                String.valueOf(inst_max1)+
                                ");");fout9.newLine();
      fout9.write("  onexit(mpc_finish);");fout9.newLine();
      fout9.write("}");fout9.newLine();
    }
    catch (Exception e1)
    {
      try
      {
        fout9.close();
      }
      catch (Exception e2)
      {}
      System.out.println("Error: Problems writing 'main' file!");
      System.exit(1);
    }
 
    try
    {
      fout9.close();
    }
    catch (Exception e3)
    {}
  }

  //*************************************************************************
  private static long getLine(String str)
  {
    long lin=0;
    String str1="";

    int x=str.lastIndexOf(";");
    if (x==-1) return -1;

    int y=str.indexOf(".", x);
    if (y==-1) return -1;

    str1=str.substring(x+1, y);
    lin=0;
    try
    {
      lin=Long.valueOf(str1).longValue();
    }
    catch (NumberFormatException nfe1)
    {}

    return lin;
  }

  //*************************************************************************
  //-1 - unknown
  // 0 - Load
  // 1 - Fload
  // 2 - Store
  // 3 - Fstore

  private static int GetInstClass(String str)
  {
    int nfop1=18;
    String[] fop1=new String [nfop1];
    fop1[ 0]="fld";
    fop1[ 1]="fild";
    fop1[ 2]="fbld";
    fop1[ 3]="fcom";
    fop1[ 4]="fcomp";
    fop1[ 5]="ficom";
    fop1[ 6]="ficomp";
    fop1[ 7]="fadd";
    fop1[ 8]="fiadd";
    fop1[ 9]="fsub";
    fop1[10]="fsubr";
    fop1[11]="fisub";
    fop1[12]="fisubr";
    fop1[13]="fmul";
    fop1[14]="fimul";
    fop1[15]="fdiv";
    fop1[16]="fidiv";
    fop1[17]="fidivr";
           
    int nfop2=6;
    String[] fop2=new String [nfop2];
    fop2[ 0]="fst";
    fop2[ 1]="fstp";
    fop2[ 2]="fist";
    fop2[ 3]="fistp";
    fop2[ 4]="fbst";
    fop2[ 5]="fbstp";

    int nop1=10;
    String[] op1=new String [nop1];
    op1[ 0]="inc";
    op1[ 1]="dec";
    op1[ 2]="neg";
    op1[ 3]="not";
    op1[ 4]="rcl";
    op1[ 5]="rcr";
    op1[ 6]="rol";
    op1[ 7]="ror";
    op1[ 8]="sal";
    op1[ 9]="sar";

    int nop2=5;
    String[] op2=new String [nop2];
    op2[ 0]="cmp";
    op2[ 1]="mul";
    op2[ 2]="imul";
    op2[ 3]="div";
    op2[ 4]="idiv";

    int nop3=9;
    String[] op3=new String [nop3];
    op3[ 0]="mov";
    op3[ 1]="add";
    op3[ 2]="adc";
    op3[ 3]="sub";
    op3[ 4]="sbb";
    op3[ 5]="and";
    op3[ 6]="test";
    op3[ 7]="or";
    op3[ 8]="xor";
    
    int i1=str.indexOf(" PTR ");
    int i2=0;
    String op="";

    if (i1!=-1)
    {
      str=str.trim();

      i2=str.indexOf(" ");
      op=str.substring(0,i2);

      if (str.charAt(0)=='f')
      {
        for (int i=0; i<nfop1; i++)
        {
          if (fop1[i].equals(op)) return 1;
        }

        for (int i=0; i<nfop2; i++)
        {
          if (fop2[i].equals(op)) return 3;
        }
      }
      else
      {
        for (int i=0; i<nop1; i++)
        {
          if (op1[i].equals(op)) return 2;
        }

        for (int i=0; i<nop2; i++)
        {
          if (op2[i].equals(op)) return 0;
        }

        for (int i=0; i<nop3; i++)
        {
          if (op3[i].equals(op))
          {
            if (str.indexOf(",", i1+1)!=-1) return 2;
            return 0;
          }
        }
      }
    }

    return -1;
  }
}
