//
// Process Messages
//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

//Import libraries...
import java.net.*;
import java.io.*;

public class ProcessMessages
{
  public ProcessMessages(Socket sockfd, CGlobal g)
  {
    int misc;

    //Initialize instructions (need to do it in each process!)
    CSIParse sip = new CSIParse();

    if (sip.Init(30, 0)!=0)
    //            |  |
    //            |  |------- Case Sensitive (0) or not (1)
    //            |
    //            |---------- Max Number of Options
    {
      System.out.println("\nError: Can't initialize object CSIParse!");
      return;
    }

    misc=0;
  
    char ch=0;
    misc =sip.Add("initiate",         1, ' ', "");   //Param  0
    misc+=sip.Add("terminate",        0, ch,  "");   //Param  1
    misc+=sip.Add("directory",        1, '=', "");   //Param  2
    misc+=sip.Add("file_project",     1, '=', "");   //Param  3
    misc+=sip.Add("file_diag_out",    1, '=', "");   //Param  4
    misc+=sip.Add("file_prof_out",    1, '=', "");   //Param  5
    misc+=sip.Add("file_tree_out",    1, '=', "");   //Param  6
    misc+=sip.Add("no_octave",        1, '=', "");   //Param  7
    misc+=sip.Add("step",             1, '=', "");   //Param  8
    misc+=sip.Add("go",               0, ch,  "");   //Param  9
    misc+=sip.Add("optimization",     1, '=', "");   //Param 10
    misc+=sip.Add("run_fdc",          0, ch,  "");   //Param 11
    misc+=sip.Add("run_umol",         0, ch,  "");   //Param 12
    misc+=sip.Add("run_fetp",         0, ch,  "");   //Param 13
    misc+=sip.Add("file_project1",    1, '=', "");   //Param 14
    misc+=sip.Add("run_fdc_fast",     0, ch,  "");   //Param 15
    misc+=sip.Add("run_prof",         0, ch,  "");   //Param 16
    misc+=sip.Add("run_llprof",       0, ch,  "");   //Param 17
    misc+=sip.Add("run_simple",       0, ch,  "");   //Param 18
    misc+=sip.Add("file_info",        1, '=', "");   //Param 19
    misc+=sip.Add("file_project_out", 1, '=', "");   //Param 20
    misc+=sip.Add("file_tree",        1, '=', "");   //Param 21
    misc+=sip.Add("file_info_out",    1, '=', "");   //Param 22
    misc+=sip.Add("option",           1, '=', "");   //Param 23
    misc+=sip.Add("create_info",      0, ch,  "");   //Param 24

    if (misc!=0)
    {
      System.out.println("\nError: Internal, while initializing CSIParse!");
      return;
    }

    //Process Instructions
    new ProcessInstructions(sockfd, g, sip);
  }      
}
