//
// Strategies
//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

//Import libraries...
import java.io.*;

public class Strategies_Search11c
{
  //**************************************************************************
  public static void Search11c(PrintWriter out,
                               CGlobal g,
                               BufferedWriter fout,
                               CProject cp,
                               CTree ctr,
                               CClient cl,
                               CTime ct1,
                               CTime ct9,
                               CTransformations1 ctrans,
                               int step1,
                               String str_prec,
                               String str_opt,
                               String str_fto1,
                               String str_fto2,
                               BufferedReader fin9,
                               boolean once,
                               int pt1, int pt2, int pt3,
                               int pu1, int pu2, int pu3,
                               int pp1, int pp2, int pp3,
                               boolean apo, boolean cdes,
                               String str_dir,
                               CLLP cllp,
                               CLLP cllp1,
                               CLLP cllp2,
                               String str_opt1,
                               String str_fp,
                               String str_dir_ic)
  {          
    int ret=0;
    int ret1=0;

    int step=0;

    String str="";

    String str_fnt="_fnt";
    String str_tmp="_tmp";

    String f_tmp      = "_eos_s_tmp";
    String f_tmp1     = "_eos_s_tmp1";

    String f_tmp_prj2 = "_eos_s_prj_tmp2"; //also the same string and name
                                           //is used in some other classes!
                                           //check before changing!

    boolean transf=true;

    boolean x_tile=false;
    boolean x_unrl=false;

    double tnew=0;

    double prec=0;
    try
    {
      prec=Double.valueOf(str_prec).doubleValue();
    }
    catch (NumberFormatException nfe1)
    {
      prec=0;
    }

    CTime ct=new CTime();

    int i=0;
    int p=0;
    int j=0;

    double best_time=ct9.GetTime0();
    double best_time1=0;

    CTime bt=new CTime();
    CTime bt1=new CTime();

    bt.Copy(ct9);
    int s_best=-1;
    int s_best1=-1;
    int transf_pos=0;
    int transf_pos1=0;

    boolean compound=false;

    CLLP cllp_best=new CLLP();
    CLLP cllp_save1=new CLLP();
    CLLP cllp_save2=new CLLP();

    //Writing time
    BufferedWriter fout1=null;

    if (!once)
    {
      try
      {
        fout1=new BufferedWriter(new FileWriter(str_fto1));
      }
      catch (IOException e1)
      {
        out.println("Error: Can't open file for writing time!");
        out.flush();
        return;
      }
    }

    try
    {
      //check number of loops and number of timers
      int nl2=0;
      
      int np=ctr.GetNumProcs();

      boolean tile=false;
      nl2=0;

      for (p=0; p<np; p++)
      {
        int nl=ctr.GetNumLoops(p);

        if (nl!=0)
        {
          for (i=0; i<nl; i++)
          {
            if (!ctr.GetParamL(p, i).equals("0"))
            {
	      tile=true;

              nl2++;
            }
  	    else
  	    {
              if (tile)
	      {
	        tile=false;
	      }
	      else
	      {
                nl2++;
              }
            }
          }
        }
      }

      fout.newLine();
      fout.write("Number of timers:     "+String.valueOf(cllp1.GetNumberOfTimers()));
      fout.newLine();
      fout.write("Number of loop nests: "+String.valueOf(nl2));
      fout.newLine();
      fout.newLine();

      if (cllp1.GetNumberOfTimers()!=nl2)
      {
        fout.newLine();
        fout.write("WARNING: Number of selected loops does not match number of timers!");
        fout.newLine();
        fout.write("");
        fout.newLine();
        fout.write("if outer loop is ^selected (tiling) -> the inner loop (unrolling)");
        fout.newLine();
        fout.write("should be selected as well! Therefore, the number of inner loops");
        fout.newLine();
        fout.write("should be the same as the number of timers!");
        fout.newLine();
        fout.write("Only 1 outer loop can be selected (i.e. one loop tiling");
        fout.newLine();
        fout.write("per loop nest)");        
        fout.newLine();
//        return;
      }

      int[]     q_tile  =new     int[nl2];
      int[]     q_tile_i=new     int[nl2];
      int[]     q_tile_p=new     int[nl2];
      int[]     q_unrl  =new     int[nl2];
      int[]     q_unrl_i=new     int[nl2];
      int[]     q_unrl_p=new     int[nl2];

      for (i=0; i<nl2; i++)
      {
        q_tile[i]=0;
	q_tile_i[i]=0;
	q_tile_p[i]=-1;
	q_unrl[i]=0;
	q_unrl_i[i]=0;
	q_unrl_p[i]=0;
      }

      tile=false;
      nl2=0;
      for (p=0; p<np; p++)
      {
        int nl=ctr.GetNumLoops(p);

        if (nl!=0)
        {
          for (i=0; i<nl; i++)
          {
            if (!ctr.GetParamL(p, i).equals("0"))
            {
	      tile=true;

	      q_tile_p[nl2]=p;
	      q_tile_i[nl2]=i;

	      cllp1.select(nl2);
	      cllp2.select(nl2);

              nl2++;
            }
  	    else
  	    {
              if (tile)
	      {
  		q_unrl_p[nl2-1]=p;
		q_unrl_i[nl2-1]=i;

  	        cllp1.select(nl2-1);
  	        cllp2.select(nl2-1);

	        tile=false;
	      }
	      else
	      {
	        q_unrl_p[nl2]=p;
	        q_unrl_i[nl2]=i;
		
  	        cllp1.select(nl2);
  	        cllp2.select(nl2);

                nl2++;
              }
            }
          }
        }
      }

      boolean best_found=false;
      int     best_type=0;
      String  best_s="";

      int     best_type1=0;
      String  best_s1="";

      //common array padding
      cllp_save1.CopyClass(cllp1);
      cllp_save2.CopyClass(cllp2);

      int nac=ctr.GetNumArraysComm();

      if (nac!=0)
      {
        fout.write("*****************************************************************************");
        fout.newLine();

        //common array padding
        for (j=pp1; j<=pp2; j+=pp3)
        {
          if (step>step1 && once) return;

          step++;

          fout.write(CMisc.align_long(step, 5));
          fout.write(") Common array padding");
          fout.newLine();
          fout.newLine();

          ctrans.RestoreQueuePosition(transf_pos);

          String s_pad=String.valueOf(j);
          fout.write("    padding factor: ");
          fout.write(s_pad);
          fout.newLine();

          for (i=0; i<nac; i++)
          {
            fout.write("    array variable: ");
            fout.write(ctr.GetNameAC(i));
            fout.newLine();

            ctrans.Add(0, 0, 0, i, s_pad, "", false);
          }

          fout.newLine();
          fout.flush();

          tnew=0;
          ret=0;

          if (step>step1) ret=ctrans.Transform(transf, step, once, cdes);
          else if (!once)
          {
            str=fin9.readLine();

            int ind1=str.indexOf("'");
            int ind2=str.indexOf("'", ind1+1);

            if ((ind1!=-1) && (ind2!=-1))
            {
              ind1=str.indexOf("'", ind2+1);
              ind2=str.indexOf("'", ind1+1);

              String tmx=str.substring(ind1+1, ind2);

              if ((ind1!=-1) && (ind2!=-1))
              {
                ind1=str.indexOf("'", ind2+1);
                ind2=str.indexOf("'", ind1+1);

                if ((ind1!=-1) && (ind2!=-1))
                {
                  String retx=str.substring(ind1+1, ind2);

                  try
                  {
                    tnew=Double.valueOf(tmx).doubleValue();
                  }
                  catch (NumberFormatException nfe1)
                  {}

                  try
                  {
                    ret=Integer.valueOf(retx).intValue();
                  }
                  catch (NumberFormatException nfe2)
                  {}
                }
              }
            }

            if (ret==0)
            {
              ret1=CMisc.CopyTextFile(str_dir+g.cfg.GetParamStr(g.cfgLLPProfFile)+
                                      "_"+CMisc.align_str1(String.valueOf(step),5,'0'),
                                      str_dir+g.cfg.GetParamStr(g.cfgLLPProfFile));
              if (ret1<0)
              {
                out.println("Error: Can't find llprof file for the step "+
                            String.valueOf(step)+"!");
                out.flush();
                return;
              }
            }
          }

          if (ret<0)
          {
            out.println(ctrans.GetLastError());
            out.flush();
            return;
          }
          else if (ret==1)
          {
            fout.write("                                          [");
            fout.write("exe was not created ...]");
            fout.newLine();
          }
          else if (ret==2)
          {
            fout.write("                                          [");
            fout.write("output is incorrect ...]");
            fout.newLine();
          }
          else if (ret==3)
          {
            fout.write("                                          [");
            fout.write("can't transform ...    ]");
            fout.newLine();
          }
          else if (ret==0)
          {
            if (step<=step1) ctrans.SetTime(String.valueOf(tnew));

            ret1=cllp.Parse();
            try
            {
              if (ret1==-1)
              {
                fout.newLine();
                fout.write("Error: Can't find file with LLP!");
                fout.newLine();
                fout.flush();
              }
              else if (ret1==-2)
              {
                fout.newLine();
                fout.write("Error: Can't parse LLP file!");
                fout.newLine();
                fout.flush();
              }
              else if (ret1==-3)
              {
                fout.newLine();
                fout.write("Error: Can't close LLP file!");
                fout.newLine();
                fout.flush();
              }
              else if (ret1<0)
              {
                fout.newLine();
                fout.write(cl.GetLastError());
                fout.newLine();
                fout.flush();
              }
            }
            catch (Exception e2)
            {
              out.println("Error: Problems while writing diagnostic files!");
              out.flush();
              return;
            }
      
            if (ret1==0)
            {
              try
              {
                cllp.Copy("_"+CMisc.align_str1(String.valueOf(step),5,'0'));

                cllp1.Comp(cllp);
                cllp2.Comp(cllp);

                int nl1=cllp.GetNumberOfTimers();
 
                fout.write("        ====================================================================================================================");
                fout.newLine();
                for (int ii=0; ii<nl1; ii++)
                {
                  fout.write("        "+cllp.PrintLine(ii)+",");
                  fout.write(" OPT1={"+cllp1.GetMin(ii)+"/"+cllp1.GetTime(ii)+" "+cllp1.GetBetter(ii)+" }");
                  if (!str_opt1.equals("0"))
                  {
                    fout.write(",  OPT2={"+cllp2.GetMin(ii)+"/"+cllp2.GetTime(ii)+" "+cllp2.GetBetter(ii)+" } ");
                  }
                  fout.newLine();
                }
                fout.write("        ====================================================================================================================");
                fout.newLine();
              }
              catch (Exception e2)
              {
                out.println("Error: Problems while writing diagnostic files!");
                out.flush();
                return;
              }
            }

            ct=ctrans.GetTime();
            ct.Align(5,1);

            tnew=ct.GetTime0();

            fout.write("                            (transformed) [Time: ");
            fout.write(ct.GetTimeStr1()+" + "+ct.GetTimeStr2()+" = "+ct.GetTimeStr0());
            fout.write("]");
            fout.newLine();

            fout.write("      (time difference for serveral runs) [Time:                     ");
            fout.write(CMisc.align_double(ctrans.GetTimeDiff(),5,1));
            fout.write("]");
            fout.newLine();
     
            fout.write("                                   (best) [Time: ");
            fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
            fout.write("]");
            fout.newLine();

            fout.write("                               (original) [Time: ");
            fout.write(ct9.GetTimeStr1()+" + "+ct9.GetTimeStr2()+" = "+ct9.GetTimeStr0());
            fout.write("]");
            fout.newLine();
   
            double dt=best_time-tnew;
            if (dt>=prec)
            {
              fout.newLine();
              fout.write("                           *** BETTER *** [Time: ");
              fout.write("                    ");
              fout.write(CMisc.align_double(dt,5,1));
              fout.write("]");
              fout.newLine();

              if (best_time==-1)
              {
                best_time=tnew;
                bt.Copy(ct);
                cllp_best.CopyClass(cllp);
                s_best=step;
                best_type=0;
                best_s=s_pad;
                best_found=true;
              }
              else if (best_time>tnew)
              {
                best_time=tnew;
                bt.Copy(ct);
                cllp_best.CopyClass(cllp);
                s_best=step;
                best_type=0;
                best_s=s_pad;
                best_found=true;
              }
            }

            fout.newLine();
            fout.flush();
          }

          if (!once)
          {
            fout1.write("'"+String.valueOf(step)+"', '"+
                            String.valueOf(tnew)+"', '"+
                            String.valueOf(ret)+"'");
            fout1.newLine();
            fout1.flush();
          }
        }

        //Choosing best transformation
        if (best_found)
        {
          best_found=false;

          //Choosing best transformation
          fout.write("-----------------------------------------------------------------------------");
          fout.newLine();

          fout.write("Best transformation found for all common arrays:");
          fout.newLine();

          fout.write(" (step=");
          fout.write(String.valueOf(s_best));
          fout.write(")!");
          fout.newLine();

          ctrans.RestoreQueuePosition(transf_pos);
          for (i=0; i<nac; i++)
          {
            ctrans.Add(0, best_type, 0, i, best_s, "", false);
          }
          transf_pos=ctrans.GetQueuePosition();

          fout.newLine();
          fout.write("Next transformations will include the above transformation!");
          fout.newLine();

          fout.write("-----------------------------------------------------------------------------");
          fout.newLine();

          fout.flush();
        }

        cllp1.CopyClass(cllp_save1);
        cllp2.CopyClass(cllp_save2);
        cllp1.Comp(cllp_best);
        cllp2.Comp(cllp_best);
        cllp1.MakeMinMain();
        cllp2.MakeMinMain();
        cllp_save1.CopyClass(cllp1);
        cllp_save2.CopyClass(cllp2);
      }

      //non-common array transformations
      for (p=0; p<np; p++)
      {
        fout.write("*****************************************************************************");
        fout.newLine();

        //Array transformations
        int na=ctr.GetNumArrays(p);

        if (na==0)
        {
          fout.write("No non-common arrays to transform!");
          fout.newLine();
        }
        else 
        {
          for (j=pp1; j<=pp2; j+=pp3)
          {
            if (step>step1 && once) return;

            step++;
        
            fout.write(CMisc.align_long(step, 5));
            fout.write(") Non-common array padding");
            fout.newLine();
            fout.newLine();

            ctrans.RestoreQueuePosition(transf_pos);

            fout.write("         procedure: ");
            fout.write(ctr.GetProc(p));
            fout.newLine();

            String s_pad=String.valueOf(j);
            fout.write("    padding factor: ");
            fout.write(s_pad);
            fout.newLine();
    
            for (i=0; i<na; i++)
            {
              fout.write("    array variable: ");
              fout.write(ctr.GetNameA(p,i));
              fout.newLine();

              ctrans.Add(1, 0, p, i, s_pad, "", false);
            }

            fout.newLine();
            fout.flush();

            tnew=0;
            ret=0;

            if (step>step1) ret=ctrans.Transform(transf, step, once, cdes);
            else if (!once)
            {
              str=fin9.readLine();

              int ind1=str.indexOf("'");
              int ind2=str.indexOf("'", ind1+1);

              if ((ind1!=-1) && (ind2!=-1))
              {
                ind1=str.indexOf("'", ind2+1);
                ind2=str.indexOf("'", ind1+1);

                String tmx=str.substring(ind1+1, ind2);

                if ((ind1!=-1) && (ind2!=-1))
                {
                  ind1=str.indexOf("'", ind2+1);
                  ind2=str.indexOf("'", ind1+1);

                  if ((ind1!=-1) && (ind2!=-1))
                  {
                    String retx=str.substring(ind1+1, ind2);

                    try
                    {
                      tnew=Double.valueOf(tmx).doubleValue();
                    }
                    catch (NumberFormatException nfe1)
                    {}

                    try
                    {
                      ret=Integer.valueOf(retx).intValue();
                    }
                    catch (NumberFormatException nfe2)
                    {}
                  }
                }
              }

              if (ret==0)
              {
                ret1=CMisc.CopyTextFile(str_dir+g.cfg.GetParamStr(g.cfgLLPProfFile)+
                                        "_"+CMisc.align_str1(String.valueOf(step),5,'0'),
                                        str_dir+g.cfg.GetParamStr(g.cfgLLPProfFile));
                if (ret1<0)
                {
                  out.println("Error: Can't find llprof file for the step "+
                              String.valueOf(step)+"!");
                  out.flush();
                  return;
                }
              }
            }

            if (ret<0)
            {
              out.println(ctrans.GetLastError());
              out.flush();
              return;
            }
            else if (ret==1)
            {
              fout.write("                                          [");
              fout.write("exe was not created ...]");
              fout.newLine();
            }
            else if (ret==2)
            {
              fout.write("                                          [");
              fout.write("output is incorrect ...]");
              fout.newLine();
            }
            else if (ret==3)
            {
              fout.write("                                          [");
              fout.write("can't transform ...    ]");
              fout.newLine();
            }  
            else if (ret==0)
            {
              if (step<=step1) ctrans.SetTime(String.valueOf(tnew));
          
              ret1=cllp.Parse();
              try
              {
                if (ret1==-1)
                {
                  fout.newLine();
                  fout.write("Error: Can't find file with LLP!");
                  fout.newLine();
                  fout.flush();
                }
                else if (ret1==-2)
                {
                  fout.newLine();
                  fout.write("Error: Can't parse LLP file!");
                  fout.newLine();
                  fout.flush();
                }
                else if (ret1==-3)
                {
                  fout.newLine();
                  fout.write("Error: Can't close LLP file!");
                  fout.newLine();
                  fout.flush();
                }
                else if (ret1<0)
                {
                  fout.newLine();
                  fout.write(cl.GetLastError());
                  fout.newLine();
                  fout.flush();
                }
              }
              catch (Exception e2)
              {
                out.println("Error: Problems while writing diagnostic files!");
                out.flush();
                return;
              }
      
              if (ret1==0)
              {
                try
                {
                  cllp.Copy("_"+CMisc.align_str1(String.valueOf(step),5,'0'));

                  cllp1.Comp(cllp);
                  cllp2.Comp(cllp);

                  int nl1=cllp.GetNumberOfTimers();
 
                  fout.write("        ====================================================================================================================");
                  fout.newLine();
                  for (int ii=0; ii<nl1; ii++)
                  {
                    fout.write("        "+cllp.PrintLine(ii)+",");
                    fout.write(" OPT1={"+cllp1.GetMin(ii)+"/"+cllp1.GetTime(ii)+" "+cllp1.GetBetter(ii)+" }");
                    if (!str_opt1.equals("0"))
                    {
                      fout.write(",  OPT2={"+cllp2.GetMin(ii)+"/"+cllp2.GetTime(ii)+" "+cllp2.GetBetter(ii)+" } ");
                    }
                    fout.newLine();
                  }
                  fout.write("        ====================================================================================================================");
                  fout.newLine();
                }
                catch (Exception e2)
                {
                  out.println("Error: Problems while writing diagnostic files!");
                  out.flush();
                  return;
                }
              }

              ct=ctrans.GetTime();
              ct.Align(5,1);

              tnew=ct.GetTime0();

              fout.write("                            (transformed) [Time: ");
              fout.write(ct.GetTimeStr1()+" + "+ct.GetTimeStr2()+" = "+ct.GetTimeStr0());
              fout.write("]");
              fout.newLine();
     
              fout.write("      (time difference for serveral runs) [Time:                     ");
              fout.write(CMisc.align_double(ctrans.GetTimeDiff(),5,1));
              fout.write("]");
              fout.newLine();
     
              fout.write("                                   (best) [Time: ");
              fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
              fout.write("]");
              fout.newLine();

              fout.write("                               (original) [Time: ");
              fout.write(ct9.GetTimeStr1()+" + "+ct9.GetTimeStr2()+" = "+ct9.GetTimeStr0());
              fout.write("]");
              fout.newLine();
   
              double dt=best_time-tnew;
              if (dt>=prec)
              {
                fout.newLine();
                fout.write("                           *** BETTER *** [Time: ");
                fout.write("                    ");
                fout.write(CMisc.align_double(dt,5,1));
                fout.write("]");
                fout.newLine();

                if (best_time==-1)
                {
                  best_time=tnew;
                  bt.Copy(ct);
                  cllp_best.CopyClass(cllp);
                  s_best=step;
                  best_s=s_pad;
                  best_found=true;
                }
                else if (best_time>tnew)
                {
                  best_time=tnew;
                  bt.Copy(ct);
                  cllp_best.CopyClass(cllp);
                  s_best=step;
                  best_s=s_pad;
                  best_found=true;
                }
              }

              fout.newLine();
              fout.flush();
            }

            if (!once)
            {
              fout1.write("'"+String.valueOf(step)+"', '"+
                              String.valueOf(tnew)+"', '"+
                              String.valueOf(ret)+"'");
              fout1.newLine();
              fout1.flush();
            }
          }

          //Choosing best transformation
          if (best_found)
          {
            best_found=false;

            //Choosing best transformation
            fout.write("-----------------------------------------------------------------------------");
            fout.newLine();

            fout.write("Best transformation found for all non-common arrays:");
            fout.newLine();

            fout.write(" (step=");
            fout.write(String.valueOf(s_best));
            fout.write(")!");
            fout.newLine();

            ctrans.RestoreQueuePosition(transf_pos);
            for (i=0; i<na; i++)
            {
              ctrans.Add(1, 0, p, i, best_s, "", false);
            }
            transf_pos=ctrans.GetQueuePosition();

            fout.newLine();
            fout.write("Next transformations will include the above transformation!");
            fout.newLine();

            fout.write("-----------------------------------------------------------------------------");
            fout.newLine();

            fout.flush();
          }
          cllp1.CopyClass(cllp_save1);
          cllp2.CopyClass(cllp_save2);
          cllp1.Comp(cllp_best);
          cllp2.Comp(cllp_best);
          cllp1.MakeMinMain();
          cllp2.MakeMinMain();
          cllp_save1.CopyClass(cllp1);
          cllp_save2.CopyClass(cllp2);
	}
      }

      //if array padding only return
      if (apo)
      {
        if (!once)
        {
          try
          {
            fout1.close();
          }
          catch (Exception e5)
          {}
        }

        return;
      }

      String s_tile="";
      String s_unrl="";

      //loop transformations
      //loop tiling
      boolean found=false;
      tile=false;
      nl2=0;
      for (p=0; p<np; p++)
      {
        int nl=ctr.GetNumLoops(p);

        if (nl!=0)
        {
          for (i=0; i<nl; i++)
          {
            if (!ctr.GetParamL(p, i).equals("0"))
            {
	      tile=true;
              found=true;

              nl2++;
            }
  	    else
  	    {
              if (tile)
	      {
	        tile=false;
	      }
	      else
	      {
                nl2++;
              }
            }
          }
        }
      }

      fout.write("*****************************************************************************");
      fout.newLine();

      if (!found)
      {
        fout.write("No loops to tile!");
        fout.newLine();
      }
      else
      {
        fout.write("Loop tiling (all procedures, all loops):");
        fout.newLine();
        fout.newLine();

        for (j=pt1; j<=pt2; j+=pt3)
        {
          if (step>step1 && once) return;

          step++;
     
          fout.write(CMisc.align_long(step, 5));
          fout.write(") Loop tiling:");
          fout.newLine();
          fout.newLine();

          s_tile=String.valueOf(j);
          fout.write("       tile factor: ");
          fout.write(s_tile);
          fout.newLine();
          fout.newLine();

          ctrans.RestoreQueuePosition(transf_pos);

          for (p=0; p<np; p++)
          {
            int nl=ctr.GetNumLoops(p);

            if (nl!=0)
            {
              for (i=0; i<nl; i++)
              {
                if (!ctr.GetParamL(p, i).equals("0"))
                {
                  fout.write("         procedure: ");
                  fout.write(ctr.GetProcL(p, i));
                  fout.newLine();

                  fout.write("     loop variable: ");
                  fout.write(ctr.GetNameL(p, i));
                  fout.newLine();

                  fout.write("        loop index: ");
                  fout.write(ctr.GetCountL(p, i));
                  fout.newLine();

                  ctrans.Add(2, 2, p, i, s_tile, "", true);
 
                  fout.newLine();
                  fout.flush();
                }
              }
            }
          }

          tnew=0;
          ret=0;

          if (step>step1) ret=ctrans.Transform(transf, step, once, cdes);
          else if (!once)
          {
            str=fin9.readLine();

            int ind1=str.indexOf("'");
            int ind2=str.indexOf("'", ind1+1);

            if ((ind1!=-1) && (ind2!=-1))
            {
              ind1=str.indexOf("'", ind2+1);
              ind2=str.indexOf("'", ind1+1);

              String tmx=str.substring(ind1+1, ind2);
          
              if ((ind1!=-1) && (ind2!=-1))
              {
                ind1=str.indexOf("'", ind2+1);
                ind2=str.indexOf("'", ind1+1);

                if ((ind1!=-1) && (ind2!=-1))
                {
                  String retx=str.substring(ind1+1, ind2);

                  try
                  {
                    tnew=Double.valueOf(tmx).doubleValue();
                  }
                  catch (NumberFormatException nfe1)
                  {}

                  try
                  {
                    ret=Integer.valueOf(retx).intValue();
                  }
                  catch (NumberFormatException nfe2)
                  {}
                }
              }
            }

            if (ret==0)
            {
              ret1=CMisc.CopyTextFile(str_dir+g.cfg.GetParamStr(g.cfgLLPProfFile)+
                                      "_"+CMisc.align_str1(String.valueOf(step),5,'0'),
                                      str_dir+g.cfg.GetParamStr(g.cfgLLPProfFile));
              if (ret1<0)
              {
                out.println("Error: Can't find llprof file for the step "+
                            String.valueOf(step)+"!");
                out.flush();
                return;
              }
            }
          }

          if (ret<0)
          {
            out.println(ctrans.GetLastError());
            out.flush();
            return;
          }
          else if (ret==1)
          {
            fout.write("                                          [");
            fout.write("exe was not created ...]");
            fout.newLine();
          }
          else if (ret==2)
          {
            fout.write("                                          [");
            fout.write("output is incorrect ...]");
            fout.newLine();
          }
          else if (ret==3)
          {
            fout.write("                                          [");
            fout.write("can't transform ...    ]");
            fout.newLine();
          }
          else if (ret==0)
          {
            if (step<=step1) ctrans.SetTime(String.valueOf(tnew));

            ret1=cllp.Parse();
            try
            {
              if (ret1==-1)
              {
                fout.newLine();
                fout.write("Error: Can't find file with LLP!");
                fout.newLine();
                fout.flush();
              }
              else if (ret1==-2)
              {
                fout.newLine();
                fout.write("Error: Can't parse LLP file!");
                fout.newLine();
                fout.flush();
              }
              else if (ret1==-3)
              {
                fout.newLine();
                fout.write("Error: Can't close LLP file!");
                fout.newLine();
                fout.flush();
              }
              else if (ret1<0)
              {
                fout.newLine();
                fout.write(cl.GetLastError());
                fout.newLine();
                fout.flush();
              }
            }
            catch (Exception e2)
            {
              out.println("Error: Problems while writing diagnostic files!");
              out.flush();
              return;
            }
      
            if (ret1==0)
            {
              try
              {
                cllp.Copy("_"+CMisc.align_str1(String.valueOf(step),5,'0'));

                cllp1.Comp(cllp);
                cllp2.Comp(cllp);

                int nl1=cllp.GetNumberOfTimers();
 
                fout.write("        ====================================================================================================================");
                fout.newLine();
                for (int ii=0; ii<nl1; ii++)
                {
                  fout.write("        "+cllp.PrintLine(ii)+",");
                  fout.write(" OPT1={"+cllp1.GetMin(ii)+"/"+cllp1.GetTime(ii)+" "+cllp1.GetBetter(ii)+" }");
                  if (!str_opt1.equals("0"))
                  {
                    fout.write(",  OPT2={"+cllp2.GetMin(ii)+"/"+cllp2.GetTime(ii)+" "+cllp2.GetBetter(ii)+" } ");
                  }
                  fout.newLine();

                  if (q_tile_p[ii]!=-1 && cllp1.isBetter(ii) && (cllp1.GetDiff(ii)>prec))
		  {
 		    q_tile[ii]=j;
                    x_tile=true;
                  }
                }
                fout.write("        ====================================================================================================================");
                fout.newLine();
              }
              catch (Exception e2)
              {
                out.println("Error: Problems while writing diagnostic files!");
                out.flush();
                return;
              }
            }

            ct=ctrans.GetTime();
            ct.Align(5,1);

            tnew=ct.GetTime0();

            fout.write("                            (transformed) [Time: ");
            fout.write(ct.GetTimeStr1()+" + "+ct.GetTimeStr2()+" = "+ct.GetTimeStr0());
            fout.write("]");
            fout.newLine();
      
            fout.write("      (time difference for serveral runs) [Time:                     ");
            fout.write(CMisc.align_double(ctrans.GetTimeDiff(),5,1));
            fout.write("]");
            fout.newLine();
     
            fout.write("                               (original) [Time: ");
            fout.write(ct9.GetTimeStr1()+" + "+ct9.GetTimeStr2()+" = "+ct9.GetTimeStr0());
            fout.write("]");
            fout.newLine();
   
            fout.newLine();
            fout.flush();
          }

          if (!once)
          {
            fout1.write("'"+String.valueOf(step)+"', '"+
                            String.valueOf(tnew)+"', '"+
                            String.valueOf(ret)+"'");
            fout1.newLine();
	    fout1.flush();
          }
        }

        //check best tiles found
        fout.write("-----------------------------------------------------------------------------");
        fout.newLine();

        fout.write("Checking if best tile parameters are found:");
	fout.newLine();
	fout.newLine();

        ctrans.RestoreQueuePosition(transf_pos);
	for (i=0; i<nl2; i++)
	{
          String str1=String.valueOf(i+1);
          int i1=str1.length();
	  for (int ij=i1; ij<5; ij++) str1="0"+str1;

          fout.write("timer "+str1+") tile ");

          if (q_tile[i]!=0)
          {
            fout.write("found: "+String.valueOf(q_tile[i]));
            ctrans.Add(2, 2, q_tile_p[i], q_tile_i[i], String.valueOf(q_tile[i]), "", true);
          }
  	  else
          {
            fout.write("not found");
          }
          fout.newLine();
        }
        fout.newLine();

        //loop tiling+unrolling
        if (x_tile)
        {
          //execute best
	  step++;

          fout.write(CMisc.align_long(step, 5));
          fout.write(") Selecting best loop tiles:");
          fout.newLine();
          fout.newLine();

	  if (step>step1) ret=ctrans.Transform(transf, step, once, cdes);
          else if (!once)
          {
            str=fin9.readLine();

            int ind1=str.indexOf("'");
            int ind2=str.indexOf("'", ind1+1);

            if ((ind1!=-1) && (ind2!=-1))
            {
              ind1=str.indexOf("'", ind2+1);
              ind2=str.indexOf("'", ind1+1);

              String tmx=str.substring(ind1+1, ind2);

              if ((ind1!=-1) && (ind2!=-1))
              {
                ind1=str.indexOf("'", ind2+1);
                ind2=str.indexOf("'", ind1+1);

                if ((ind1!=-1) && (ind2!=-1))
                {
                  String retx=str.substring(ind1+1, ind2);

                  try
                  {
                    tnew=Double.valueOf(tmx).doubleValue();
                  }
                  catch (NumberFormatException nfe1)
                  {}

                  try
                  {
                    ret=Integer.valueOf(retx).intValue();
                  }
                  catch (NumberFormatException nfe2)
                  {}
                }
              }
            }

            if (ret==0)
            {
              ret1=CMisc.CopyTextFile(str_dir+g.cfg.GetParamStr(g.cfgLLPProfFile)+
                                      "_"+CMisc.align_str1(String.valueOf(step),5,'0'),
                                      str_dir+g.cfg.GetParamStr(g.cfgLLPProfFile));
              if (ret1<0)
              {
                out.println("Error: Can't find llprof file for the step "+
                            String.valueOf(step)+"!");
                out.flush();
                return;
              }
            }
          }

          if (ret<0)
          {
            out.println(ctrans.GetLastError());
            out.flush();
            return;
          }
          else if (ret==1)
          {
            fout.write("                                          [");
            fout.write("exe was not created ...]");
            fout.newLine();
          }
          else if (ret==2)
          {
            fout.write("                                          [");
            fout.write("output is incorrect ...]");
            fout.newLine();
          }
          else if (ret==3)
          {
            fout.write("                                          [");
            fout.write("can't transform ...    ]");
            fout.newLine();
          }
          else if (ret==0)
          {
            if (step<=step1) ctrans.SetTime(String.valueOf(tnew));

            ret1=cllp.Parse();
            try
            {
              if (ret1==-1)
              {
                fout.newLine();
                fout.write("Error: Can't find file with LLP!");
                fout.newLine();
                fout.flush();
              }
              else if (ret1==-2)
              {
                fout.newLine();
                fout.write("Error: Can't parse LLP file!");
                fout.newLine();
                fout.flush();
              }
              else if (ret1==-3)
              {
                fout.newLine();
                fout.write("Error: Can't close LLP file!");
                fout.newLine();
                fout.flush();
              }
              else if (ret1<0)
              {
                fout.newLine();
                fout.write(cl.GetLastError());
                fout.newLine();
                fout.flush();
              }
            }
            catch (Exception e2)
            {
              out.println("Error: Problems while writing diagnostic files!");
              out.flush();
              return;
            }
      
            if (ret1==0)
            {
              try
              {
                cllp.Copy("_"+CMisc.align_str1(String.valueOf(step),5,'0'));

                cllp1.CleanBetter();
                cllp1.Comp(cllp);
                cllp2.CleanBetter();
                cllp2.Comp(cllp);

                int nl1=cllp.GetNumberOfTimers();
 
                fout.write("        ====================================================================================================================");
                fout.newLine();
                for (int ii=0; ii<nl1; ii++)
                {
                  fout.write("        "+cllp.PrintLine(ii)+",");
                  fout.write(" OPT1={"+cllp1.GetMin(ii)+"/"+cllp1.GetTime(ii)+" "+cllp1.GetBetter(ii)+" }");
                  if (!str_opt1.equals("0"))
                  {
                    fout.write(",  OPT2={"+cllp2.GetMin(ii)+"/"+cllp2.GetTime(ii)+" "+cllp2.GetBetter(ii)+" } ");
                  }
                  fout.newLine();
                }
                fout.write("        ====================================================================================================================");
                fout.newLine();
              }
              catch (Exception e2)
              {
                out.println("Error: Problems while writing diagnostic files!");
                out.flush();
                return;
              }
            }

            ct=ctrans.GetTime();
            ct.Align(5,1);

            tnew=ct.GetTime0();

            fout.write("                            (transformed) [Time: ");
            fout.write(ct.GetTimeStr1()+" + "+ct.GetTimeStr2()+" = "+ct.GetTimeStr0());
            fout.write("]");
            fout.newLine();
     
            fout.write("      (time difference for serveral runs) [Time:                     ");
            fout.write(CMisc.align_double(ctrans.GetTimeDiff(),5,1));
            fout.write("]");
            fout.newLine();
     
            fout.write("                                   (best) [Time: ");
            fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
            fout.write("]");
            fout.newLine();

            fout.write("                               (original) [Time: ");
            fout.write(ct9.GetTimeStr1()+" + "+ct9.GetTimeStr2()+" = "+ct9.GetTimeStr0());
            fout.write("]");
            fout.newLine();
   
            double dt=best_time-tnew;
            if (dt>=prec)
            {
              fout.newLine();
              fout.write("                           *** BETTER *** [Time: ");
              fout.write("                    ");
              fout.write(CMisc.align_double(dt,5,1));
              fout.write("]");
              fout.newLine();

              if (best_time==-1)
              {
                best_time=tnew;
                bt.Copy(ct);
                best_found=true;
              }
              else if (best_time>tnew)
              {
                best_time=tnew;
                bt.Copy(ct);
                best_found=true;
              }
            }

            fout.newLine();
            fout.flush();
          }

          if (!once)
          {
            fout1.write("'"+String.valueOf(step)+"', '"+
                            String.valueOf(tnew)+"', '"+
                            String.valueOf(ret)+"'");
            fout1.newLine();
            fout1.flush();
          }

          fout.write("-----------------------------------------------------------------------------");
          fout.newLine();

          //transform
          x_unrl=false;

          transf_pos1=ctrans.GetQueuePosition();

          fout.write("*****************************************************************************");
          fout.newLine();

          fout.write("Loop tiling + unrolling (all procedures, all loops):");
          fout.newLine();
          fout.newLine();

          for (j=pu1; j<=pu2; j+=pu3)
          {
            if (step>step1 && once) return;

            step++;

            fout.write(CMisc.align_long(step, 5));
            fout.write(") Loop tiling + unrolling:");
            fout.newLine();
            fout.newLine();

            s_unrl=String.valueOf(j);
            fout.write("  unrolling factor: ");
            fout.write(s_unrl);
            fout.newLine();

            tile=false;
            for (p=0; p<np; p++)
            {
              int nl=ctr.GetNumLoops(p);

              if (nl!=0)
              {
                for (i=0; i<nl; i++)
                {
                  if (!ctr.GetParamL(p, i).equals("0")) tile=true;
	          else
                  {
                    if (tile)
	            {
	              tile=false;
		      
                      fout.write("         procedure: ");
                      fout.write(ctr.GetProcL(p, i));
                      fout.newLine();

                      fout.write("     loop variable: ");
                      fout.write(ctr.GetNameL(p, i));
                      fout.newLine();
  
                      fout.write("        loop index: ");
                      fout.write(ctr.GetCountL(p, i));
                      fout.newLine();

                      ctrans.Add(2, 4, p, i, s_unrl, "", true);
         
                      fout.newLine();
                      fout.flush();
                    }
                  }
                }
              }
            }

            tnew=0;
            ret=0;

            if (step>step1) ret=ctrans.Transform(transf, step, once, cdes);
            else if (!once)
            {
              str=fin9.readLine();

              int ind1=str.indexOf("'");
              int ind2=str.indexOf("'", ind1+1);

              if ((ind1!=-1) && (ind2!=-1))
              {
                ind1=str.indexOf("'", ind2+1);
                ind2=str.indexOf("'", ind1+1);

                String tmx=str.substring(ind1+1, ind2);
                
                if ((ind1!=-1) && (ind2!=-1))
                {
                  ind1=str.indexOf("'", ind2+1);
                  ind2=str.indexOf("'", ind1+1);

                  if ((ind1!=-1) && (ind2!=-1))
                  {
                    String retx=str.substring(ind1+1, ind2);

                    try
                    {
                      tnew=Double.valueOf(tmx).doubleValue();
                    }
                    catch (NumberFormatException nfe1)
                    {}

                    try
                    {
                      ret=Integer.valueOf(retx).intValue();
                    }
                    catch (NumberFormatException nfe2)
                    {}
                  }
                }
              }

              if (ret==0)
              {
                ret1=CMisc.CopyTextFile(str_dir+g.cfg.GetParamStr(g.cfgLLPProfFile)+
                                        "_"+CMisc.align_str1(String.valueOf(step),5,'0'),
                                        str_dir+g.cfg.GetParamStr(g.cfgLLPProfFile));
                if (ret1<0)
                {
                  out.println("Error: Can't find llprof file for the step "+
                              String.valueOf(step)+"!");
                  out.flush();
                  return;
                }
              }
            }

            if (ret<0)
            {
              out.println(ctrans.GetLastError());
              out.flush();
              return;
            }
            else if (ret==1)
            {
              fout.write("                                          [");
              fout.write("exe was not created ...]");
              fout.newLine();
            }
            else if (ret==2)
            {
              fout.write("                                          [");
              fout.write("output is incorrect ...]");
              fout.newLine();
            }
            else if (ret==3)
            {
              fout.write("                                          [");
              fout.write("can't transform ...    ]");
              fout.newLine();
            }
            else if (ret==0)
            {
              if (step<=step1) ctrans.SetTime(String.valueOf(tnew));
              ret1=cllp.Parse();
              try
              {
                if (ret1==-1)
                {
                  fout.newLine();
                  fout.write("Error: Can't find file with LLP!");
                  fout.newLine();
                  fout.flush();
                }
                else if (ret1==-2)
                {
                  fout.newLine();
                  fout.write("Error: Can't parse LLP file!");
                  fout.newLine();
                  fout.flush();
                }
                else if (ret1==-3)
                {
                  fout.newLine();
                  fout.write("Error: Can't close LLP file!");
                  fout.newLine();
                  fout.flush();
                }
                else if (ret1<0)
                {
                  fout.newLine();
                  fout.write(cl.GetLastError());
                  fout.newLine();
                  fout.flush();
                }
              }
              catch (Exception e2)
              {
                out.println("Error: Problems while writing diagnostic files!");
                out.flush();
                return;
              }
      
              if (ret1==0)
              {
                try
                {
                  cllp.Copy("_"+CMisc.align_str1(String.valueOf(step),5,'0'));

                  cllp1.Comp(cllp);
                  cllp2.Comp(cllp);

                  int nl1=cllp.GetNumberOfTimers();
         
                  fout.write("        ====================================================================================================================");
                  fout.newLine();
                  for (int ii=0; ii<nl1; ii++)
                  {
                    fout.write("        "+cllp.PrintLine(ii)+",");
                    fout.write(" OPT1={"+cllp1.GetMin(ii)+"/"+cllp1.GetTime(ii)+" "+cllp1.GetBetter(ii)+" }");
                    if (!str_opt1.equals("0"))
                    {
                      fout.write(",  OPT2={"+cllp2.GetMin(ii)+"/"+cllp2.GetTime(ii)+" "+cllp2.GetBetter(ii)+" } ");
                    }
                    fout.newLine();
 
                    if (cllp1.isBetter(ii) && (cllp1.GetDiff(ii)>prec))
                    {
    	              q_unrl[ii]=j;
                      x_unrl=true;
                    }
                  }
                  fout.write("        ====================================================================================================================");
                  fout.newLine();
                }
                catch (Exception e2)
                {
                  out.println("Error: Problems while writing diagnostic files!");
                  out.flush();
                  return;
                }
              }

              ct=ctrans.GetTime();
              ct.Align(5,1);

              tnew=ct.GetTime0();
         
              fout.write("                            (transformed) [Time: ");
              fout.write(ct.GetTimeStr1()+" + "+ct.GetTimeStr2()+" = "+ct.GetTimeStr0());
              fout.write("]");
              fout.newLine();
      
              fout.write("      (time difference for serveral runs) [Time:                     ");
              fout.write(CMisc.align_double(ctrans.GetTimeDiff(),5,1));
              fout.write("]");
              fout.newLine();
     
              fout.write("                               (original) [Time: ");
              fout.write(ct9.GetTimeStr1()+" + "+ct9.GetTimeStr2()+" = "+ct9.GetTimeStr0());
              fout.write("]");
              fout.newLine();
   
              fout.newLine();
              fout.flush();
            }

            if (!once)
            {
              fout1.write("'"+String.valueOf(step)+"', '"+
                              String.valueOf(tnew)+"', '"+
                              String.valueOf(ret)+"'");  
              fout1.newLine();
              fout1.flush();
            }
          }

          //check best unroll found
          fout.write("-----------------------------------------------------------------------------");
          fout.newLine();

          fout.write("Checking if best unroll parameters are found:");
          fout.newLine();
          fout.newLine();

          ctrans.RestoreQueuePosition(transf_pos1);
          for (i=0; i<nl2; i++)
          {
            String str1=String.valueOf(i+1);  
            int i1=str1.length();
            for (int ij=i1; ij<5; ij++) str1="0"+str1;

            fout.write("timer "+str1+") unroll (with tile) ");
            if (q_unrl[i]!=0)
            {
              fout.write("found: "+String.valueOf(q_unrl[i]));
              ctrans.Add(2, 4, q_unrl_p[i], q_unrl_i[i], String.valueOf(q_unrl[i]), "", true);
              x_unrl=true;
            }
            else
            {
              fout.write("not found");
    	    }
            fout.newLine();
          }
          fout.newLine();
        }
	
        if (x_unrl)
        {
          //execute best
          step++;

          fout.write(CMisc.align_long(step, 5));
          fout.write(") Selecting best loop tiling+unrolling:");
          fout.newLine();
          fout.newLine();

  	  if (step>step1) ret=ctrans.Transform(transf, step, once, cdes);
          else if (!once)
          {
            str=fin9.readLine();

            int ind1=str.indexOf("'");
            int ind2=str.indexOf("'", ind1+1);

            if ((ind1!=-1) && (ind2!=-1))
            {
              ind1=str.indexOf("'", ind2+1);
              ind2=str.indexOf("'", ind1+1);

              String tmx=str.substring(ind1+1, ind2);

              if ((ind1!=-1) && (ind2!=-1))
              {
                ind1=str.indexOf("'", ind2+1);
                ind2=str.indexOf("'", ind1+1);

                if ((ind1!=-1) && (ind2!=-1))
                {
                  String retx=str.substring(ind1+1, ind2);

                  try
                  {
                    tnew=Double.valueOf(tmx).doubleValue();
                  }
                  catch (NumberFormatException nfe1)
                  {}

                  try
                  {
                    ret=Integer.valueOf(retx).intValue();
                  }
                  catch (NumberFormatException nfe2)
                  {}
                }
              }
            }

            if (ret==0)
            {
              ret1=CMisc.CopyTextFile(str_dir+g.cfg.GetParamStr(g.cfgLLPProfFile)+
                                      "_"+CMisc.align_str1(String.valueOf(step),5,'0'),
                                      str_dir+g.cfg.GetParamStr(g.cfgLLPProfFile));
              if (ret1<0)
              {
                out.println("Error: Can't find llprof file for the step "+
                            String.valueOf(step)+"!");
                out.flush();
                return;
              }
            }
          }

          if (ret<0)
          {
            out.println(ctrans.GetLastError());
            out.flush();
            return;
          }
          else if (ret==1)
          {
            fout.write("                                          [");
            fout.write("exe was not created ...]");
            fout.newLine();
          }
          else if (ret==2)
          {
            fout.write("                                          [");
            fout.write("output is incorrect ...]");
            fout.newLine();
          }
          else if (ret==3)
          {
            fout.write("                                          [");
            fout.write("can't transform ...    ]");
            fout.newLine();
          }
          else if (ret==0)
          {
            if (step<=step1) ctrans.SetTime(String.valueOf(tnew));

            ret1=cllp.Parse();
            try
            {
              if (ret1==-1)
              {
                fout.newLine();
                fout.write("Error: Can't find file with LLP!");
                fout.newLine();
                fout.flush();
              }
              else if (ret1==-2)
              {
                fout.newLine();
                fout.write("Error: Can't parse LLP file!");
                fout.newLine();
                fout.flush();
              }
              else if (ret1==-3)
              {
                fout.newLine();
                fout.write("Error: Can't close LLP file!");
                fout.newLine();
                fout.flush();
              }
              else if (ret1<0)
              {
                fout.newLine();
                fout.write(cl.GetLastError());
                fout.newLine();
                fout.flush();
              }
            }
            catch (Exception e2)
            {
              out.println("Error: Problems while writing diagnostic files!");
              out.flush();
              return;
            }
  
            if (ret1==0)
            {
              try
              {
                cllp.Copy("_"+CMisc.align_str1(String.valueOf(step),5,'0'));

                cllp1.CleanBetter();
                cllp1.Comp(cllp);
                cllp2.CleanBetter();
                cllp2.Comp(cllp);

                int nl1=cllp.GetNumberOfTimers();
 
                fout.write("        ====================================================================================================================");
                fout.newLine();
                for (int ii=0; ii<nl1; ii++)
                {
                  fout.write("        "+cllp.PrintLine(ii)+",");
                  fout.write(" OPT1={"+cllp1.GetMin(ii)+"/"+cllp1.GetTime(ii)+" "+cllp1.GetBetter(ii)+" }");
                  if (!str_opt1.equals("0"))
                  {
                    fout.write(",  OPT2={"+cllp2.GetMin(ii)+"/"+cllp2.GetTime(ii)+" "+cllp2.GetBetter(ii)+" } ");
                  }
                  fout.newLine();
                }
                fout.write("        ====================================================================================================================");
                fout.newLine();
              }
              catch (Exception e2)
              {
                out.println("Error: Problems while writing diagnostic files!");
                out.flush();
                return;
              }
            }

            ct=ctrans.GetTime();
            ct.Align(5,1);

            tnew=ct.GetTime0();

            fout.write("                            (transformed) [Time: ");
            fout.write(ct.GetTimeStr1()+" + "+ct.GetTimeStr2()+" = "+ct.GetTimeStr0());
            fout.write("]");
            fout.newLine();
     
            fout.write("      (time difference for serveral runs) [Time:                     ");
            fout.write(CMisc.align_double(ctrans.GetTimeDiff(),5,1));
            fout.write("]");
            fout.newLine();
     
            fout.write("                                   (best) [Time: ");
            fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
            fout.write("]");
            fout.newLine();

            fout.write("                               (original) [Time: ");
            fout.write(ct9.GetTimeStr1()+" + "+ct9.GetTimeStr2()+" = "+ct9.GetTimeStr0());
            fout.write("]");
            fout.newLine();
   
            double dt=best_time-tnew;
            if (dt>=prec)
            {
              fout.newLine();
              fout.write("                           *** BETTER *** [Time: ");
              fout.write("                    ");
              fout.write(CMisc.align_double(dt,5,1));
              fout.write("]");
              fout.newLine();

              if (best_time==-1)
              {
                best_time=tnew;
                bt.Copy(ct);
                best_found=true;
              }
              else if (best_time>tnew)
              {
                best_time=tnew;
                bt.Copy(ct);
                best_found=true;
              }
            }
  
            fout.newLine();
            fout.flush();
          }

          if (!once)
          {
            fout1.write("'"+String.valueOf(step)+"', '"+
                            String.valueOf(tnew)+"', '"+
                            String.valueOf(ret)+"'");
            fout1.newLine();
            fout1.flush();
          }
        }
      
        fout.write("-----------------------------------------------------------------------------");
        fout.newLine();
      }
      
      //loop unroll
      ctrans.RestoreQueuePosition(transf_pos);

      found=false;
      for (j=pt1; j<=pt2; j+=pt3)
      {
        for (p=0; p<np; p++)
        {
          int nl=ctr.GetNumLoops(p);

          if (nl!=0)
          {
            for (i=0; i<nl; i++)
            {
              if (ctr.GetParamL(p, i).equals("0"))
              {
                found=true;
              }
            }
          }
        }
      }

      if (!found)
      {
        fout.write("No loops to unroll!");
        fout.newLine();
      }
      else
      {
        x_unrl=false;

        fout.write("*****************************************************************************");
        fout.newLine();

        fout.write("Loop unrolling (all procedures, all loops):");
        fout.newLine();
        fout.newLine();

        for (j=pu1; j<=pu2; j+=pu3)
        {
          if (step>step1 && once) return;
   
          step++;

          fout.write(CMisc.align_long(step, 5));
          fout.write(") Loop unrolling:");
          fout.newLine();
          fout.newLine();

          s_unrl=String.valueOf(j);
          fout.write("  unrolling factor: ");
          fout.write(s_unrl);
          fout.newLine();

          ctrans.RestoreQueuePosition(transf_pos);

          for (p=0; p<np; p++)
          {
            int nl=ctr.GetNumLoops(p);

            if (nl!=0)
            {
              for (i=0; i<nl; i++)
              {
                if (ctr.GetParamL(p, i).equals("0"))
                {
                  fout.write("         procedure: ");
                  fout.write(ctr.GetProcL(p, i));
                  fout.newLine();

                  fout.write("     loop variable: ");
                  fout.write(ctr.GetNameL(p, i));
                  fout.newLine();

                  fout.write("        loop index: ");
                  fout.write(ctr.GetCountL(p, i));
                  fout.newLine();

                  ctrans.Add(2, 4, p, i, s_unrl, "", true);

                  fout.newLine();
                  fout.flush();

                  tnew=0;
                  ret=0;
                }
              }
            }
          }

          if (step>step1) ret=ctrans.Transform(transf, step, once, cdes);
          else if (!once)
          {
            str=fin9.readLine();

            int ind1=str.indexOf("'");
            int ind2=str.indexOf("'", ind1+1);

            if ((ind1!=-1) && (ind2!=-1))
            {
              ind1=str.indexOf("'", ind2+1);
              ind2=str.indexOf("'", ind1+1);

              String tmx=str.substring(ind1+1, ind2);

              if ((ind1!=-1) && (ind2!=-1))
              {
                ind1=str.indexOf("'", ind2+1);
                ind2=str.indexOf("'", ind1+1);

                if ((ind1!=-1) && (ind2!=-1))
                {
                  String retx=str.substring(ind1+1, ind2);

                  try
                  {
                    tnew=Double.valueOf(tmx).doubleValue();
                  }
                  catch (NumberFormatException nfe1)
                  {}

                  try
                  {
                    ret=Integer.valueOf(retx).intValue();
                  }
                  catch (NumberFormatException nfe2)
                  {}
                }
              }
            }

            if (ret==0)
            {
              ret1=CMisc.CopyTextFile(str_dir+g.cfg.GetParamStr(g.cfgLLPProfFile)+
                                      "_"+CMisc.align_str1(String.valueOf(step),5,'0'),
                                      str_dir+g.cfg.GetParamStr(g.cfgLLPProfFile));
              if (ret1<0)
              {
                out.println("Error: Can't find llprof file for the step "+
                            String.valueOf(step)+"!");
                out.flush();
                return;
              }
            }
          }

          if (ret<0)
          {
            out.println(ctrans.GetLastError());
            out.flush();
            return;
          }
          else if (ret==1)
          {
            fout.write("                                          [");
            fout.write("exe was not created ...]");
            fout.newLine();
          }
          else if (ret==2)
          {
            fout.write("                                          [");
            fout.write("output is incorrect ...]");
            fout.newLine();
          }
          else if (ret==3)
          {
            fout.write("                                          [");
            fout.write("can't transform ...    ]");
            fout.newLine();
          }
          else if (ret==0)
          {
            if (step<=step1) ctrans.SetTime(String.valueOf(tnew));

            ret1=cllp.Parse();
            try
            {
              if (ret1==-1)
              {
                fout.newLine();
                fout.write("Error: Can't find file with LLP!");
                fout.newLine();
                fout.flush();
              }
              else if (ret1==-2)
              {
                fout.newLine();
                fout.write("Error: Can't parse LLP file!");
                fout.newLine();
                fout.flush();
              }
              else if (ret1==-3)
              {
                fout.newLine();
                fout.write("Error: Can't close LLP file!");
                fout.newLine();
                fout.flush();
              }
              else if (ret1<0)
              {
                fout.newLine();
                fout.write(cl.GetLastError());
                fout.newLine();
                fout.flush();
              }
            }
            catch (Exception e2)
            {
              out.println("Error: Problems while writing diagnostic files!");
              out.flush();
              return;
            }
      
            if (ret1==0)
            {
              try
              {
                cllp.Copy("_"+CMisc.align_str1(String.valueOf(step),5,'0'));

                cllp1.Comp(cllp);
                cllp2.Comp(cllp);

                int nl1=cllp.GetNumberOfTimers();
 
                fout.write("        ====================================================================================================================");
                fout.newLine();
                for (int ii=0; ii<nl1; ii++)
                {
                  fout.write("        "+cllp.PrintLine(ii)+",");
                  fout.write(" OPT1={"+cllp1.GetMin(ii)+"/"+cllp1.GetTime(ii)+" "+cllp1.GetBetter(ii)+" }");
                  if (!str_opt1.equals("0"))
                  {
                    fout.write(",  OPT2={"+cllp2.GetMin(ii)+"/"+cllp2.GetTime(ii)+" "+cllp2.GetBetter(ii)+" } ");
                  }
                  fout.newLine();

                  if (cllp1.isBetter(ii) && (cllp1.GetDiff(ii)>prec))
     	          {
                    q_tile[ii]=0; //clean tile
 		    q_unrl[ii]=j;
                    x_unrl=true;
                  }
                }
                fout.write("        ====================================================================================================================");
                fout.newLine();
              }
              catch (Exception e2)
              {
                out.println("Error: Problems while writing diagnostic files!");
                out.flush();
                return;
              }
            }

            ct=ctrans.GetTime();
            ct.Align(5,1);

            tnew=ct.GetTime0();

            fout.write("                            (transformed) [Time: ");
            fout.write(ct.GetTimeStr1()+" + "+ct.GetTimeStr2()+" = "+ct.GetTimeStr0());
            fout.write("]");
            fout.newLine();
      
            fout.write("      (time difference for serveral runs) [Time:                     ");
            fout.write(CMisc.align_double(ctrans.GetTimeDiff(),5,1));
            fout.write("]");
            fout.newLine();
     
            fout.write("                               (original) [Time: ");
            fout.write(ct9.GetTimeStr1()+" + "+ct9.GetTimeStr2()+" = "+ct9.GetTimeStr0());
            fout.write("]");
            fout.newLine();
   
            fout.newLine();
            fout.flush();
          }

          if (!once)
          {
            fout1.write("'"+String.valueOf(step)+"', '"+
                            String.valueOf(tnew)+"', '"+
                            String.valueOf(ret)+"'");
            fout1.newLine();
            fout1.flush();
          }
        }

        //Choosing best transformation (tile, tile+unroll, unroll)
        fout.write("-----------------------------------------------------------------------------");
        fout.newLine();

        fout.write("Checking if best tile, tile+unroll, unroll parameters are found:");
        fout.newLine();
        fout.newLine();

        x_unrl=false;
        ctrans.RestoreQueuePosition(transf_pos);
        for (i=0; i<nl2; i++)
        {
          String str1=String.valueOf(i+1);
          int i1=str1.length();
          for (int ij=i1; ij<5; ij++) str1="0"+str1;
 
          fout.write("timer "+str1+") ");

          if ((q_tile[i]!=0) || (q_unrl[i]!=0)) x_unrl=true;

          if (q_tile[i]!=0)
	  {
            fout.write("tile found: "+String.valueOf(q_tile[i])+"    ");
            ctrans.Add(2, 2, q_tile_p[i], q_tile_i[i], String.valueOf(q_tile[i]), "", true);
	  }
	  else
	  {
            fout.write("tile not found    ");
	  }

          if (q_unrl[i]!=0)
          {
            fout.write("unroll found: "+String.valueOf(q_unrl[i]));
            ctrans.Add(2, 4, q_unrl_p[i], q_unrl_i[i], String.valueOf(q_unrl[i]), "", true);
          }
          else
          {
            fout.write("unroll not found");
  	  }
          fout.newLine();
        }
      }
      fout.newLine();
      fout.flush();

      if (x_unrl)
      {
        //execute best
        if (step>step1 && once) return;

	step++;

        s_best=step;

        fout.write(CMisc.align_long(step, 5));
        fout.write(") Selecting best loop tiling, tiling+unrolling, unrolling:");
        fout.newLine();
        fout.newLine();

	if (step>step1) ret=ctrans.Transform(transf, step, once, cdes);
        else if (!once)
        {
          str=fin9.readLine();

          int ind1=str.indexOf("'");
          int ind2=str.indexOf("'", ind1+1);

          if ((ind1!=-1) && (ind2!=-1))
          {
            ind1=str.indexOf("'", ind2+1);
            ind2=str.indexOf("'", ind1+1);

            String tmx=str.substring(ind1+1, ind2);

            if ((ind1!=-1) && (ind2!=-1))
            {
              ind1=str.indexOf("'", ind2+1);
              ind2=str.indexOf("'", ind1+1);

              if ((ind1!=-1) && (ind2!=-1))
              {
                String retx=str.substring(ind1+1, ind2);

                try
                {
                  tnew=Double.valueOf(tmx).doubleValue();
                }
                catch (NumberFormatException nfe1)
                {}

                try
                {
                  ret=Integer.valueOf(retx).intValue();
                }
                catch (NumberFormatException nfe2)
                {}
              }
            }
          }

          if (ret==0)
          {
            ret1=CMisc.CopyTextFile(str_dir+g.cfg.GetParamStr(g.cfgLLPProfFile)+
                                    "_"+CMisc.align_str1(String.valueOf(step),5,'0'),
                                    str_dir+g.cfg.GetParamStr(g.cfgLLPProfFile));
            if (ret1<0)
            {
              out.println("Error: Can't find llprof file for the step "+
                          String.valueOf(step)+"!");
              out.flush();
              return;
            }
          }
        }

        if (ret<0)
        {
          out.println(ctrans.GetLastError());
          out.flush();
          return;
        }
        else if (ret==1)
        {
          fout.write("                                          [");
          fout.write("exe was not created ...]");
          fout.newLine();
        }
        else if (ret==2)
        {
          fout.write("                                          [");
          fout.write("output is incorrect ...]");
          fout.newLine();
        }
        else if (ret==3)
        {
          fout.write("                                          [");
          fout.write("can't transform ...    ]");
          fout.newLine();
        }
        else if (ret==0)
        {
          if (step<=step1) ctrans.SetTime(String.valueOf(tnew));

          ret1=cllp.Parse();
          try
          {
            if (ret1==-1)
            {
              fout.newLine();
              fout.write("Error: Can't find file with LLP!");
              fout.newLine();
              fout.flush();
            }
            else if (ret1==-2)
            {
              fout.newLine();
              fout.write("Error: Can't parse LLP file!");
              fout.newLine();
              fout.flush();
            }
            else if (ret1==-3)
            {
              fout.newLine();
              fout.write("Error: Can't close LLP file!");
              fout.newLine();
              fout.flush();
            }
            else if (ret1<0)
            {
              fout.newLine();
              fout.write(cl.GetLastError());
              fout.newLine();
              fout.flush();
            }
          }
          catch (Exception e2)
          {
            out.println("Error: Problems while writing diagnostic files!");
            out.flush();
            return;
          }
  
          if (ret1==0)
          {
            try
            {
              cllp.Copy("_"+CMisc.align_str1(String.valueOf(step),5,'0'));

              cllp1.CleanBetter();
              cllp1.Comp(cllp);
              cllp2.CleanBetter();
              cllp2.Comp(cllp);

              int nl1=cllp.GetNumberOfTimers();

              fout.write("        ====================================================================================================================");
              fout.newLine();
              for (int ii=0; ii<nl1; ii++)
              {
                fout.write("        "+cllp.PrintLine(ii)+",");
                fout.write(" OPT1={"+cllp1.GetMin(ii)+"/"+cllp1.GetTime(ii)+" "+cllp1.GetBetter(ii)+" }");
                if (!str_opt1.equals("0"))
                {
                  fout.write(",  OPT2={"+cllp2.GetMin(ii)+"/"+cllp2.GetTime(ii)+" "+cllp2.GetBetter(ii)+" } ");
                }
                fout.newLine();
              }
              fout.write("        ====================================================================================================================");
              fout.newLine();
            }
            catch (Exception e2)
            {
              out.println("Error: Problems while writing diagnostic files!");
              out.flush();
              return;
            }
          }

          ct=ctrans.GetTime();
          ct.Align(5,1);

          tnew=ct.GetTime0();

          fout.write("                            (transformed) [Time: ");
          fout.write(ct.GetTimeStr1()+" + "+ct.GetTimeStr2()+" = "+ct.GetTimeStr0());
          fout.write("]");
          fout.newLine();
     
          fout.write("      (time difference for serveral runs) [Time:                     ");
          fout.write(CMisc.align_double(ctrans.GetTimeDiff(),5,1));
          fout.write("]");
          fout.newLine();
   
          fout.write("                                   (best) [Time: ");
          fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
          fout.write("]");
          fout.newLine();

          fout.write("                               (original) [Time: ");
          fout.write(ct9.GetTimeStr1()+" + "+ct9.GetTimeStr2()+" = "+ct9.GetTimeStr0());
          fout.write("]");
          fout.newLine();
   
          double dt=best_time-tnew;
          if (dt>=prec)
          {
            fout.newLine();
            fout.write("                           *** BETTER *** [Time: ");
            fout.write("                    ");
            fout.write(CMisc.align_double(dt,5,1));
            fout.write("]");
            fout.newLine();

            if (best_time==-1)
            {
              best_time=tnew;
              bt.Copy(ct);
              best_found=true;
            }
            else if (best_time>tnew)
            {
              best_time=tnew;
              bt.Copy(ct);
              best_found=true;
            }
          }

          fout.newLine();
          fout.flush();
        }

        if (!once)
        {
          fout1.write("'"+String.valueOf(step)+"', '"+
                          String.valueOf(tnew)+"', '"+
                          String.valueOf(ret)+"'");
          fout1.newLine();
          fout1.flush();
        }
      }

      fout.write("-----------------------------------------------------------------------------");
      fout.newLine();

      fout.write("Result: ");
      fout.newLine();
      fout.newLine();

      if (s_best!=-1)
      {
        fout.write("                                   (best) [Time: ");
        fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
        fout.write("]");
        fout.newLine();

        fout.write("                              (original) [TimeA: ");
        fout.write(ct1.GetTimeStr1()+" + "+ct1.GetTimeStr2()+" = "+ct1.GetTimeStr0());
        fout.write("]");
        fout.newLine();

        if (!str_opt1.equals("0"))
        {
          fout.write("                              (original) [TimeB: ");
          fout.write(ct9.GetTimeStr1()+" + "+ct9.GetTimeStr2()+" = "+ct9.GetTimeStr0());
          fout.write("]");
          fout.newLine();
        }

        double dt=ct1.GetTime0()-best_time;
        double dp=0;

        if (dt>0)
        {
          fout.newLine();
          fout.write("                          *** BETTER *** [TimeA: ");
          fout.write("                    ");
          fout.write(CMisc.align_double(dt,5,1));
          fout.write("]");
          fout.newLine();
          fout.newLine();
        
          fout.write("                                          [      ");
          fout.write("                     ");
          dp=dt*100/ct1.GetTime0();  
          fout.write(CMisc.align_double(dp,3,1)+"%");
          fout.write("]");
          fout.newLine();
        }

        if (!str_opt1.equals("0"))
        {
          dt=ct9.GetTime0()-best_time;
          fout.newLine();
          fout.write("                          *** BETTER *** [TimeB: ");
          fout.write("                    ");
          fout.write(CMisc.align_double(dt,5,1));
          fout.write("]");
          fout.newLine();
          fout.newLine();
        
          fout.write("                                          [      ");
          fout.write("                     ");
          dp=dt*100/ct9.GetTime0();  
          fout.write(CMisc.align_double(dp,3,1)+"%");
          fout.write("]");
          fout.newLine();
        }

        fout.newLine();
        fout.write("Last step with improvement: "+String.valueOf(s_best));
        fout.newLine();

        //running best version but without timers using opt and opt1

        fout.write("*****************************************************************************");
        fout.newLine();
          
        fout.write("Creating project with best transformations and removing timers...");
        fout.newLine();
        fout.newLine();
        if (!cdes)
        {
          fout.write("Error: Option for creating dirs during each iterative step should be turned on!");
          fout.newLine();
        }
        else
        {
          //Project from the best step
          String str1=String.valueOf(s_best);
          String str2="";
          int ii=str1.length();
          int im=g.cfg.GetParamInt(g.cfgDirAddAlgn);
          for (j=0; j<im-ii; j++) str2+="0";
          str2+=str1;
          str2=CMisc.ProcessDir(str_dir_ic, g.cfg.GetParamStr(g.cfgSeparator))+
               g.cfg.GetParamStr(g.cfgDirAdd1)+str2;

          str2+=g.cfg.GetParamStr(g.cfgSeparator);
          String str2q=str2;
          str2+=f_tmp_prj2;

          fout.write("Project name with the best step: "+str2);
          fout.newLine();

          String fnt1=str_dir+str2;

          //Loading and parsing project file from the best step
          fout.write("Loading and parsing project file from the best step: ");

          CProject cpq = new CProject();

          if (cpq.Init(g.lng, fnt1, 4096)!=0)
          {
            fout.newLine();
            fout.write("Error (internal): Can't initialize object CProject!");
            fout.newLine();
            fout.flush();
            return;
          }

          if (cpq.Parse()<0)
          {
            fout.newLine();
            fout.write(cpq.GetLastError());
            fout.newLine();
            fout.flush();
            return;
          }
          if (cpq.ParseLng()<0)
          {
            fout.newLine();
            fout.write(cpq.GetLastError());
            fout.newLine();
            fout.flush();
            return;
          }

          fout.write("Ok");
          fout.newLine();

          //creating new project and removing timers
          fout.write("Creating new project: ");

          String fnt2=str_dir+str_fp+str_fnt;

          CProject cpx = new CProject();
          cpx.Init(cp, fnt2);

          for (j=1; j<cp.GetNumFiles(); j++)
          {
            found=false;

            for (int k=1; k<cpq.GetNumFiles(); k++)
            {
              str1=cpq.GetFileName(k);
              ii=str1.indexOf(str_tmp);

              if (ii>=0) str1=str1.substring(0,ii);

              if (str1.equals(cp.GetFileName(j)) &&
                  cpq.GetFileExt(k).equals(cp.GetFileExt(j)))
              {
                found=true;
                break;
              }
            }

            if (!found)
            {
              cpx.AddLine1(cp.GetLngNameOrig(j), cp.GetFileName(j),
                           cp.GetFileExt(j), cp.GetExtraOpt(j));
            }
            else
            {
              cpx.AddLine1(cpq.GetLngNameOrig(j), cpq.GetFileName(j)+str_fnt,
                           cpq.GetFileExt(j), cpq.GetExtraOpt(j));

              //removing eos_timer from the old file
              BufferedReader fin4=null;
              BufferedWriter fout4=null;

              str1=str_dir+str2q+cpq.GetFileName(j)+cpq.GetFileExt(j);
              str2=str_dir+cpq.GetFileName(j)+str_fnt+cpq.GetFileExt(j);

              try
              {
                 fin4=new BufferedReader(new FileReader(str1));
                fout4=new BufferedWriter(new FileWriter(str2));
              }
              catch (IOException e2)
              {
                fout.write("Error opening file with timers ("+cpq.GetFileName(j)+")!");
                fout.newLine();
                fout.flush();
                return;
              }

              try
              {
                while ((str2=fin4.readLine())!=null)
                {
                  ii=str2.toLowerCase().indexOf(g.cfg.GetParamStr(g.cfgDelEOSTimer).toLowerCase());
                  if (ii>=0) str2="";

                  fout4.write(str2);
                  fout4.newLine();
                }
              }
              catch (Exception e1)
              {
                try
                {
                  fin4.close();
                  fout4.close();
                }
                catch (Exception e2)
                {}
                fout.write("Error while removing eos_timers from the source file!");
                fout.newLine();
                fout.flush();
                return;
              }

              try
              {
                fin4.close();
                fout4.close();
              }
              catch (Exception e3)
              {}
            }
          }

          if (cpx.Save()<0)
          {
            fout.newLine();
            fout.write("Error: Can't save new project ("+cpx.GetLastError()+")!");
            fout.newLine();

            return;
          }

          fout.write("Ok");
          fout.newLine();

          //Compiling and running original applications
          fout.newLine();

          fout.write("Compiling (optimization="+str_opt+"), running & coping output files ...");
          fout.newLine();
          fout.newLine();
          fout.write("  Compiling:     ");
          fout.flush();

          cl.Add("initiate compilation",          true, true);
          cl.Add("directory="+str_dir,            true, true);
          cl.Add("file_project="+str_fp+str_fnt,  true, true);
          cl.Add("file_diag_out="+f_tmp,          true, true);
          cl.Add("compilation_mode=0",            true, true);
          cl.Add("no_checking=0",                 true, true);
          cl.Add("optimizations="+str_opt,        true, true);
          cl.Add("compile",                       true, true);
          cl.Add("terminate",                    false, true);

          ret=cl.Send();
          if (ret==-1)
          {
            out.println("Error: Can't find host with Compilation Server!");
            out.flush();
            return;
          }
          else if (ret==-2)
          {
            out.println("Error: Can't connect to Compilation Server!");
            out.flush();
            return;
          }
          else if (ret==-4)
          {
            out.println("Error: Can't close connection with Compilation Server!");
            out.flush();
            return;
          }
          else if (ret<0)
          {
            out.println(cl.GetLastError());
            out.flush();
            return;
          }

          fout.write("Ok");
          fout.newLine();
                             
          fout.write("  Running:       ");
          fout.flush();

          cl.Add("initiate compilation",          true, true);
          cl.Add("directory="+str_dir,            true, true);
          cl.Add("file_project="+str_fp+str_fnt,  true, true);
          cl.Add("file_out_time="+f_tmp1,         true, true);
          cl.Add("runmode=0",                     true, true);
          cl.Add("run",                           true, true);
          cl.Add("terminate",                    false, true);

          ret=cl.Send();
          if (ret==-1)
          {
            out.println("Error: Can't find host with Compilation Server!");
            out.flush();
            return;
          }
          else if (ret==-2)
          {
            out.println("Error: Can't connect to Compilation Server!");
            out.flush();
            return;
          }
          else if (ret==-4)
          {
            out.println("Error: Can't close connection with Compilation Server!");
            out.flush();
            return;
          }
          else if (ret<0)
          {
            out.println(cl.GetLastError());
            out.flush();
            return;
          }

          fout.write("Ok");
          fout.newLine();
          fout.flush();

          //Get time
          if (ct.Init(str_dir+f_tmp1)<0)
          {
            out.println(ct.GetLastError());
            out.flush();
            return;
          }

          ct.Align(5,1);

          fout.write("                                          [Time: ");
          fout.write(ct.GetTimeStr1());
          fout.write(" + ");      
          fout.write(ct.GetTimeStr2());
          fout.write(" = ");
          fout.write(ct.GetTimeStr0());
          fout.write("]");
          fout.newLine();
          fout.newLine();

          double ttt1=ct.GetTime0();

          if (!str_opt.equals(str_opt1) && !str_opt1.equals("0"))
          {
            fout.newLine();

            fout.write("Compiling (optimization="+str_opt1+"), running & coping output files ...");
            fout.newLine();
            fout.newLine();
            fout.write("  Compiling:     ");
            fout.flush();
   
            cl.Add("initiate compilation",          true, true);
            cl.Add("directory="+str_dir,            true, true);
            cl.Add("file_project="+str_fp+str_fnt,  true, true);
            cl.Add("file_diag_out="+f_tmp,          true, true);
            cl.Add("compilation_mode=0",            true, true);
            cl.Add("no_checking=0",                 true, true);
            cl.Add("optimizations="+str_opt1,       true, true);
            cl.Add("compile",                       true, true);
            cl.Add("terminate",                    false, true);
        
            ret=cl.Send();
            if (ret==-1)
            {
              out.println("Error: Can't find host with Compilation Server!");
              out.flush();
              return;
            }
            else if (ret==-2)
            {
              out.println("Error: Can't connect to Compilation Server!");
              out.flush();
              return;
            }
            else if (ret==-4)
            {  
              out.println("Error: Can't close connection with Compilation Server!");
              out.flush();
              return;
            }
            else if (ret<0)
            {
              out.println(cl.GetLastError());
              out.flush();
              return;
            }

            fout.write("Ok");
            fout.newLine();
                             
            fout.write("  Running:       ");
            fout.flush();

            cl.Add("initiate compilation",          true, true);
            cl.Add("directory="+str_dir,            true, true);
            cl.Add("file_project="+str_fp+str_fnt,  true, true);
            cl.Add("file_out_time="+f_tmp1,         true, true);
            cl.Add("runmode=0",                     true, true);
            cl.Add("run",                           true, true);
            cl.Add("terminate",                    false, true);

            ret=cl.Send();
            if (ret==-1)
            {
              out.println("Error: Can't find host with Compilation Server!");
              out.flush();
              return;
            }
            else if (ret==-2)
            {
              out.println("Error: Can't connect to Compilation Server!");
              out.flush();
              return;
            }
            else if (ret==-4)
            {
              out.println("Error: Can't close connection with Compilation Server!");
              out.flush();
              return;
            }
            else if (ret<0)
            {
              out.println(cl.GetLastError());
              out.flush();
              return;
            }

            fout.write("Ok");
            fout.newLine();
            fout.flush();

            //Get time
            if (ct.Init(str_dir+f_tmp1)<0)
            {
              out.println(ct.GetLastError());
              out.flush();
              return;
            }

            ct.Align(5,1);

            fout.write("                                          [Time: ");
            fout.write(ct.GetTimeStr1());
            fout.write(" + ");      
            fout.write(ct.GetTimeStr2());
            fout.write(" = ");
            fout.write(ct.GetTimeStr0());
            fout.write("]");
            fout.newLine();
            fout.newLine();
          }

          //check if project file name has _llp and run project with llp
          i=str_fp.indexOf("_llp");
          if (i>0)
          {
            String str_fp1=str_fp.substring(0,i);
  
            fout.write("*****************************************************************************");
            fout.newLine();

            fout.write("Detected _llp in the name of the project file!");
            fout.newLine();
            fout.write("==> for comparison running project "+str_fp1);
            fout.newLine();
     
            fout.newLine();

            fout.write("Compiling (optimization="+str_opt+" only), running & coping output files ...");
            fout.newLine();
            fout.newLine();
            fout.write("  Compiling:     ");
            fout.flush();

            cl.Add("initiate compilation",   true, true);
            cl.Add("directory="+str_dir,     true, true);
            cl.Add("file_project="+str_fp1,   true, true);
            cl.Add("file_diag_out="+f_tmp,   true, true);
            cl.Add("compilation_mode=0",     true, true);
            cl.Add("no_checking=0",          true, true);
            cl.Add("optimizations="+str_opt, true, true);
            cl.Add("compile",                true, true);
            cl.Add("terminate",             false, true);

            ret=cl.Send();
            if (ret==-1)
            {
              out.println("Error: Can't find host with Compilation Server!");
              out.flush();
              return;
            }
            else if (ret==-2)
            {
              out.println("Error: Can't connect to Compilation Server!");
              out.flush();
              return;
            }
            else if (ret==-4)
            {
              out.println("Error: Can't close connection with Compilation Server!");
              out.flush();
              return;
            }
            else if (ret<0)
            {
              out.println(cl.GetLastError());
              out.flush();
              return;
            }

            fout.write("Ok");
            fout.newLine();
                             
            fout.write("  Running:       ");
            fout.flush();

            cl.Add("initiate compilation",   true, true);
            cl.Add("directory="+str_dir,     true, true);
            cl.Add("file_project="+str_fp1,  true, true);
            cl.Add("file_out_time="+f_tmp1,  true, true);
            cl.Add("runmode=0",              true, true);
            cl.Add("run",                    true, true);
            cl.Add("terminate",             false, true);

            ret=cl.Send();
            if (ret==-1)
            {
              out.println("Error: Can't find host with Compilation Server!");
              out.flush();
              return;
            }
            else if (ret==-2)
            {
              out.println("Error: Can't connect to Compilation Server!");
              out.flush();
              return;
            }
            else if (ret==-4)
            {
              out.println("Error: Can't close connection with Compilation Server!");
              out.flush();
              return;
            }
            else if (ret<0)
            {
              out.println(cl.GetLastError());
              out.flush();
              return;
            }

            fout.write("Ok");
            fout.newLine();
            fout.flush();
     
            //Get time
            if (ct.Init(str_dir+f_tmp1)<0)
            {
              out.println(ct.GetLastError());
              out.flush();
              return;
            }

            ct.Align(5,1);
    
            fout.write("                                          [Time: ");
            fout.write(ct.GetTimeStr1());
            fout.write(" + ");      
            fout.write(ct.GetTimeStr2());
            fout.write(" = ");
            fout.write(ct.GetTimeStr0());
            fout.write("]");
            fout.newLine();
            fout.newLine();

            double ttt2=ct.GetTime0();

            dt=ttt2-ttt1;
            if (dt>=0)
            {
              fout.newLine();
              fout.write("                           *** BETTER *** [Time: ");
              fout.write("                    ");
              fout.write(CMisc.align_double(dt,5,1));
              fout.write("]");
              fout.newLine();

              fout.write("                                          [      ");
              fout.write("                     ");
              dp=dt*100/ttt2;  
              fout.write(CMisc.align_double(dp,3,1)+"%");
              fout.write("]");
              fout.newLine();
            }
          }
        }

        fout.newLine();
        fout.flush();
      }
      else
      {
        fout.write("Best combined transformation was not found!");
        fout.newLine();
      }
    }
    catch (Exception e2)
    {
      out.println("Error: Problems while writing diagnostic files!");
      out.flush();
      return;
    }

    if (!once)
    {
      try
      {
        fout1.close();
      }
      catch (Exception e5)
      {}
    }
  }
}
